/* sos/lambda3_star.c */

/*--------------------------------------------------------------------------*/

#include "internal.h"
#include "primitive.h"

/*--------------------------------------------------------------------------*/

Static_Declarations ("lambda3_star", 3, 4, 2);

#include "primitive.i.c"

/*--------------------------------------------------------------------------*/

SoS_primitive_result * sos_lambda3_star (j, k)
     int j, k;
     /* Returns significant term of Lambda3_star epsilon-determinant.
        Assumes indices in proper range, pairwise different, and sorted.
        Also, the *-row with index 0 has to be set. */
{
#ifdef __DEBUG__
  if (sos_proto_e_flag)
    {
      lia_clear ();
      print ("sos_lambda3_star (%d,%d)", j, k);
      print (" (");
      print ("*,*,*;");
      print ("%s,%s,1;", Pi(j,1), Pi(j,2));
      print ("%s,%s,1;", Pi(k,1), Pi(k,2));
      print (")\n");
    }
#endif
/* C code generated by 'ccode' from 'gee' file "Lambda3.star.out" */
Initialize_Star ();
Epsilon_Term (0);
Positive_Coefficient (Minor3 (0, j, k, 1, 2, 0));
Epsilon_Term (1);
Epsilon (j,2);
Positive_Coefficient (Minor2 (0, k, 1, 0));
Epsilon_Term (2);
Epsilon (j,1);
Negative_Coefficient (Minor2 (0, k, 2, 0));
Epsilon_Term (3);
Epsilon (k,2);
Negative_Coefficient (Minor2 (0, j, 1, 0));
Epsilon_Term (4);
Epsilon (k,2);
Epsilon (j,1);
Positive_Coefficient (Minor1 (0, 0));
Finish ();
}
