/* sos/lambda4_star.c */

/*--------------------------------------------------------------------------*/

#include "internal.h"
#include "primitive.h"

/*--------------------------------------------------------------------------*/

Static_Declarations ("lambda4_star", 4, 14, 3);

#include "primitive.i.c"

/*--------------------------------------------------------------------------*/

SoS_primitive_result * sos_lambda4_star (j, k, l)
     int j, k, l;
     /* returns significant term of Lambda4_star epsilon-determinant;
        Assumes indices in proper range, pairwise different, and sorted.
        Also, the *-row with index 0 has to be set. */
{
#ifdef __DEBUG__
  if (sos_proto_e_flag)
    {
      lia_clear ();
      print ("sos_lambda4_star (%d,%d)", j, k);
      print (" (");
      print ("*,*,*,*;");
      print ("%s,%s,%s,1;", Pi(j,1), Pi(j,2), Pi(j,3));
      print ("%s,%s,%s,1;", Pi(k,1), Pi(k,2), Pi(k,3));
      print ("%s,%s,%s,1;", Pi(l,1), Pi(l,2), Pi(l,3));
      print (")\n");
    }
#endif
/* C code generated by 'ccode' from 'gee' file "Lambda4.star.out" */
Initialize_Star ();
Epsilon_Term (0);
Positive_Coefficient (Minor4 (0, j, k, l, 1, 2, 3, 0));
Epsilon_Term (1);
Epsilon (j,3);
Negative_Coefficient (Minor3 (0, k, l, 1, 2, 0));
Epsilon_Term (2);
Epsilon (j,2);
Positive_Coefficient (Minor3 (0, k, l, 1, 3, 0));
Epsilon_Term (3);
Epsilon (j,1);
Negative_Coefficient (Minor3 (0, k, l, 2, 3, 0));
Epsilon_Term (4);
Epsilon (k,3);
Positive_Coefficient (Minor3 (0, j, l, 1, 2, 0));
Epsilon_Term (5);
Epsilon (k,3);
Epsilon (j,2);
Positive_Coefficient (Minor2 (0, l, 1, 0));
Epsilon_Term (6);
Epsilon (k,3);
Epsilon (j,1);
Negative_Coefficient (Minor2 (0, l, 2, 0));
Epsilon_Term (7);
Epsilon (k,2);
Negative_Coefficient (Minor3 (0, j, l, 1, 3, 0));
Epsilon_Term (8);
Epsilon (k,2);
Epsilon (j,1);
Positive_Coefficient (Minor2 (0, l, 3, 0));
Epsilon_Term (9);
Epsilon (k,1);
Positive_Coefficient (Minor3 (0, j, l, 2, 3, 0));
Epsilon_Term (10);
Epsilon (l,3);
Negative_Coefficient (Minor3 (0, j, k, 1, 2, 0));
Epsilon_Term (11);
Epsilon (l,3);
Epsilon (j,2);
Negative_Coefficient (Minor2 (0, k, 1, 0));
Epsilon_Term (12);
Epsilon (l,3);
Epsilon (j,1);
Positive_Coefficient (Minor2 (0, k, 2, 0));
Epsilon_Term (13);
Epsilon (l,3);
Epsilon (k,2);
Positive_Coefficient (Minor2 (0, j, 1, 0));
Epsilon_Term (14);
Epsilon (l,3);
Epsilon (k,2);
Epsilon (j,1);
Negative_Coefficient (Minor1 (0, 0));
Finish ();
}
