/* sos/rho2_den.c */

#if !defined(lint)  /* otherwise, it's too slow */

/*--------------------------------------------------------------------------*/

#include "geom/basic.h"
#include "geom/sos.h"
#include "internal.h"
#include "primitive.h"

/*--------------------------------------------------------------------------*/

Static_Declarations ("rho2_den", 3, 20, 4);

#include "../sos/primitive.i.c"

/*--------------------------------------------------------------------------*/

SoS_primitive_result * sos_rho2_den (i, j, k)
     int i, j, k;
     /* Returns significant term of Rho2 denumerator. */
{
#ifdef __DEBUG__
  if (sos_proto_e_flag)
    {
      lia_clear ();
      print ("sos_rho2_den (%d,%d,%d)", i, j, k);
      print (" (");
      print ("%s,%s,%s;", Pi(i,1), Pi(i,2), Pi(i,3));
      print ("%s,%s,%s;", Pi(j,1), Pi(j,2), Pi(j,3));
      print ("%s,%s,%s;", Pi(k,1), Pi(k,2), Pi(k,3));
      print (")\n");
    }
#endif
/* C code generated by 'ccode' from 'gee' file "Rho2.den" */
Initialize ();
Epsilon_Term (0);
Push (Integer (4));
Push (Minor3 (i, j, k, 1, 2, 0));
Push (Integer (2));
Power ();
Push (Minor3 (i, j, k, 1, 3, 0));
Push (Integer (2));
Power ();
Push (Minor3 (i, j, k, 2, 3, 0));
Push (Integer (2));
Power ();
Plus ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (1);
Epsilon (i,3);
Push (Integer (-8));
Push (Minor2 (j, k, 1, 0));
Push (Minor3 (i, j, k, 1, 3, 0));
Times ();
Push (Minor2 (j, k, 2, 0));
Push (Minor3 (i, j, k, 2, 3, 0));
Times ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (2);
Epsilon (i,3);
Epsilon (i,3);
Push (Integer (4));
Push (Minor2 (j, k, 1, 0));
Push (Integer (2));
Power ();
Push (Minor2 (j, k, 2, 0));
Push (Integer (2));
Power ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (3);
Epsilon (i,2);
Push (Integer (8));
Push (Minor2 (j, k, 1, 0));
Push (Minor3 (i, j, k, 1, 2, 0));
Times ();
Push (Minor2 (j, k, 3, 0));
Push (Minor3 (i, j, k, 2, 3, 0));
Times ();
Plus ();
Minus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (4);
Epsilon (i,2);
Epsilon (i,3);
Push (Integer (-8));
Push (Minor2 (j, k, 2, 0));
Push (Minor2 (j, k, 3, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (5);
Epsilon (i,2);
Epsilon (i,2);
Push (Integer (4));
Push (Minor2 (j, k, 1, 0));
Push (Integer (2));
Power ();
Push (Minor2 (j, k, 3, 0));
Push (Integer (2));
Power ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (6);
Epsilon (i,1);
Push (Integer (8));
Push (Minor2 (j, k, 2, 0));
Push (Minor3 (i, j, k, 1, 2, 0));
Times ();
Push (Minor2 (j, k, 3, 0));
Push (Minor3 (i, j, k, 1, 3, 0));
Times ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (7);
Epsilon (i,1);
Epsilon (i,3);
Push (Integer (-8));
Push (Minor2 (j, k, 1, 0));
Push (Minor2 (j, k, 3, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (8);
Epsilon (i,1);
Epsilon (i,2);
Push (Integer (-8));
Push (Minor2 (j, k, 1, 0));
Push (Minor2 (j, k, 2, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (9);
Epsilon (i,1);
Epsilon (i,1);
Push (Integer (4));
Push (Minor2 (j, k, 2, 0));
Push (Integer (2));
Power ();
Push (Minor2 (j, k, 3, 0));
Push (Integer (2));
Power ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (10);
Epsilon (j,3);
Push (Integer (8));
Push (Minor2 (i, k, 1, 0));
Push (Minor3 (i, j, k, 1, 3, 0));
Times ();
Push (Minor2 (i, k, 2, 0));
Push (Minor3 (i, j, k, 2, 3, 0));
Times ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (11);
Epsilon (j,3);
Epsilon (i,3);
Push (Integer (-8));
Push (Minor2 (i, k, 1, 0));
Push (Minor2 (j, k, 1, 0));
Times ();
Push (Minor2 (i, k, 2, 0));
Push (Minor2 (j, k, 2, 0));
Times ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (12);
Epsilon (j,3);
Epsilon (i,2);
Push (Integer (8));
Push (Minor2 (i, k, 2, 0));
Push (Minor2 (j, k, 3, 0));
Times ();
Push (Minor3 (i, j, k, 2, 3, 0));
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (13);
Epsilon (j,3);
Epsilon (i,2);
Epsilon (i,3);
Push (Integer (-8));
Push (Minor2 (j, k, 2, 0));
Times ();
Coefficient (Pop ());
Epsilon_Term (14);
Epsilon (j,3);
Epsilon (i,2);
Epsilon (i,2);
Push (Integer (8));
Push (Minor2 (j, k, 3, 0));
Times ();
Coefficient (Pop ());
Epsilon_Term (15);
Epsilon (j,3);
Epsilon (i,1);
Push (Integer (8));
Push (Minor2 (i, k, 1, 0));
Push (Minor2 (j, k, 3, 0));
Times ();
Push (Minor3 (i, j, k, 1, 3, 0));
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (16);
Epsilon (j,3);
Epsilon (i,1);
Epsilon (i,3);
Push (Integer (-8));
Push (Minor2 (j, k, 1, 0));
Times ();
Coefficient (Pop ());
Epsilon_Term (17);
Epsilon (j,3);
Epsilon (i,1);
Epsilon (i,1);
Push (Integer (8));
Push (Minor2 (j, k, 3, 0));
Times ();
Coefficient (Pop ());
Epsilon_Term (18);
Epsilon (j,3);
Epsilon (j,3);
Push (Integer (4));
Push (Minor2 (i, k, 1, 0));
Push (Integer (2));
Power ();
Push (Minor2 (i, k, 2, 0));
Push (Integer (2));
Power ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (19);
Epsilon (j,3);
Epsilon (j,3);
Epsilon (i,2);
Push (Integer (8));
Push (Minor2 (i, k, 2, 0));
Times ();
Coefficient (Pop ());
Epsilon_Term (20);
Epsilon (j,3);
Epsilon (j,3);
Epsilon (i,2);
Epsilon (i,2);
Push (Integer (4));
Coefficient (Pop ());
Finish ();
}

#endif  /* #if !defined(lint) */
