/* sos/rho3_den.c */

#if !defined(lint)  /* lint takes forever! */

/*--------------------------------------------------------------------------*/

#include "geom/basic.h"
#include "geom/sos.h"
#include "internal.h"
#include "primitive.h"

/*--------------------------------------------------------------------------*/

Static_Declarations ("rho3_den", 4, 103, 6);

#include "../sos/primitive.i.c"

/*--------------------------------------------------------------------------*/

SoS_primitive_result * sos_rho3_den (i, j, k, l)
     int i, j, k, l;
     /* Returns significant term of Rho3 denumerator. */
{
#ifdef __DEBUG__
  if (sos_proto_e_flag)
    {
      lia_clear ();
      print ("sos_rho3_den (%d,%d,%d,%d)", i, j, k, l);
      print (" (");
      print ("%s,%s,%s,%s;", Pi(i,1), Pi(i,2), Pi(i,3), Pi(i,4));
      print ("%s,%s,%s,%s;", Pi(j,1), Pi(j,2), Pi(j,3), Pi(j,4));
      print ("%s,%s,%s,%s;", Pi(k,1), Pi(k,2), Pi(k,3), Pi(k,4));
      print ("%s,%s,%s,%s;", Pi(l,1), Pi(l,2), Pi(l,3), Pi(l,4));
      print (")\n");
    }
#endif
/* C code generated by 'ccode' from 'gee' file "Rho3.den" */
Initialize ();
Epsilon_Term (0);
Push (Integer (4));
Push (Minor4 (i, j, k, l, 1, 2, 3, 0));
Push (Integer (2));
Power ();
Times ();
Coefficient (Pop ());
Epsilon_Term (1);
Epsilon (i,3);
Push (Integer (8));
Push (Minor3 (j, k, l, 1, 2, 0));
Push (Minor4 (i, j, k, l, 1, 2, 3, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (2);
Epsilon (i,3);
Epsilon (i,3);
Push (Integer (4));
Push (Minor3 (j, k, l, 1, 2, 0));
Push (Integer (2));
Power ();
Times ();
Coefficient (Pop ());
Epsilon_Term (3);
Epsilon (i,2);
Push (Integer (-8));
Push (Minor3 (j, k, l, 1, 3, 0));
Push (Minor4 (i, j, k, l, 1, 2, 3, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (4);
Epsilon (i,2);
Epsilon (i,3);
Push (Integer (-8));
Push (Minor3 (j, k, l, 1, 2, 0));
Push (Minor3 (j, k, l, 1, 3, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (5);
Epsilon (i,2);
Epsilon (i,2);
Push (Integer (4));
Push (Minor3 (j, k, l, 1, 3, 0));
Push (Integer (2));
Power ();
Times ();
Coefficient (Pop ());
Epsilon_Term (6);
Epsilon (i,1);
Push (Integer (8));
Push (Minor3 (j, k, l, 2, 3, 0));
Push (Minor4 (i, j, k, l, 1, 2, 3, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (7);
Epsilon (i,1);
Epsilon (i,3);
Push (Integer (8));
Push (Minor3 (j, k, l, 1, 2, 0));
Push (Minor3 (j, k, l, 2, 3, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (8);
Epsilon (i,1);
Epsilon (i,2);
Push (Integer (-8));
Push (Minor3 (j, k, l, 1, 3, 0));
Push (Minor3 (j, k, l, 2, 3, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (9);
Epsilon (i,1);
Epsilon (i,1);
Push (Integer (4));
Push (Minor3 (j, k, l, 2, 3, 0));
Push (Integer (2));
Power ();
Times ();
Coefficient (Pop ());
Epsilon_Term (10);
Epsilon (j,3);
Push (Integer (-8));
Push (Minor3 (i, k, l, 1, 2, 0));
Push (Minor4 (i, j, k, l, 1, 2, 3, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (11);
Epsilon (j,3);
Epsilon (i,3);
Push (Integer (-8));
Push (Minor3 (i, k, l, 1, 2, 0));
Push (Minor3 (j, k, l, 1, 2, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (12);
Epsilon (j,3);
Epsilon (i,2);
Push (Integer (8));
Push (Minor3 (i, k, l, 1, 2, 0));
Push (Minor3 (j, k, l, 1, 3, 0));
Times ();
Push (Minor2 (k, l, 1, 0));
Push (Minor4 (i, j, k, l, 1, 2, 3, 0));
Times ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (13);
Epsilon (j,3);
Epsilon (i,2);
Epsilon (i,3);
Push (Integer (8));
Push (Minor2 (k, l, 1, 0));
Push (Minor3 (j, k, l, 1, 2, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (14);
Epsilon (j,3);
Epsilon (i,2);
Epsilon (i,2);
Push (Integer (-8));
Push (Minor2 (k, l, 1, 0));
Push (Minor3 (j, k, l, 1, 3, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (15);
Epsilon (j,3);
Epsilon (i,1);
Push (Integer (-8));
Push (Minor3 (i, k, l, 1, 2, 0));
Push (Minor3 (j, k, l, 2, 3, 0));
Times ();
Push (Minor2 (k, l, 2, 0));
Push (Minor4 (i, j, k, l, 1, 2, 3, 0));
Times ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (16);
Epsilon (j,3);
Epsilon (i,1);
Epsilon (i,3);
Push (Integer (-8));
Push (Minor2 (k, l, 2, 0));
Push (Minor3 (j, k, l, 1, 2, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (17);
Epsilon (j,3);
Epsilon (i,1);
Epsilon (i,2);
Push (Integer (8));
Push (Minor2 (k, l, 2, 0));
Push (Minor3 (j, k, l, 1, 3, 0));
Times ();
Push (Minor2 (k, l, 1, 0));
Push (Minor3 (j, k, l, 2, 3, 0));
Times ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (18);
Epsilon (j,3);
Epsilon (i,1);
Epsilon (i,1);
Push (Integer (-8));
Push (Minor2 (k, l, 2, 0));
Push (Minor3 (j, k, l, 2, 3, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (19);
Epsilon (j,3);
Epsilon (j,3);
Push (Integer (4));
Push (Minor3 (i, k, l, 1, 2, 0));
Push (Integer (2));
Power ();
Times ();
Coefficient (Pop ());
Epsilon_Term (20);
Epsilon (j,3);
Epsilon (j,3);
Epsilon (i,2);
Push (Integer (-8));
Push (Minor2 (k, l, 1, 0));
Push (Minor3 (i, k, l, 1, 2, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (21);
Epsilon (j,3);
Epsilon (j,3);
Epsilon (i,2);
Epsilon (i,2);
Push (Integer (4));
Push (Minor2 (k, l, 1, 0));
Push (Integer (2));
Power ();
Times ();
Coefficient (Pop ());
Epsilon_Term (22);
Epsilon (j,3);
Epsilon (j,3);
Epsilon (i,1);
Push (Integer (8));
Push (Minor2 (k, l, 2, 0));
Push (Minor3 (i, k, l, 1, 2, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (23);
Epsilon (j,3);
Epsilon (j,3);
Epsilon (i,1);
Epsilon (i,2);
Push (Integer (-8));
Push (Minor2 (k, l, 1, 0));
Push (Minor2 (k, l, 2, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (24);
Epsilon (j,3);
Epsilon (j,3);
Epsilon (i,1);
Epsilon (i,1);
Push (Integer (4));
Push (Minor2 (k, l, 2, 0));
Push (Integer (2));
Power ();
Times ();
Coefficient (Pop ());
Epsilon_Term (25);
Epsilon (j,2);
Push (Integer (8));
Push (Minor3 (i, k, l, 1, 3, 0));
Push (Minor4 (i, j, k, l, 1, 2, 3, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (26);
Epsilon (j,2);
Epsilon (i,3);
Push (Integer (8));
Push (Minor3 (i, k, l, 1, 3, 0));
Push (Minor3 (j, k, l, 1, 2, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (27);
Epsilon (j,2);
Epsilon (i,2);
Push (Integer (-8));
Push (Minor3 (i, k, l, 1, 3, 0));
Push (Minor3 (j, k, l, 1, 3, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (28);
Epsilon (j,2);
Epsilon (i,1);
Push (Integer (8));
Push (Minor3 (i, k, l, 1, 3, 0));
Push (Minor3 (j, k, l, 2, 3, 0));
Times ();
Push (Minor2 (k, l, 3, 0));
Push (Minor4 (i, j, k, l, 1, 2, 3, 0));
Times ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (29);
Epsilon (j,2);
Epsilon (i,1);
Epsilon (i,3);
Push (Integer (8));
Push (Minor2 (k, l, 3, 0));
Push (Minor3 (j, k, l, 1, 2, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (30);
Epsilon (j,2);
Epsilon (i,1);
Epsilon (i,2);
Push (Integer (-8));
Push (Minor2 (k, l, 3, 0));
Push (Minor3 (j, k, l, 1, 3, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (31);
Epsilon (j,2);
Epsilon (i,1);
Epsilon (i,1);
Push (Integer (8));
Push (Minor2 (k, l, 3, 0));
Push (Minor3 (j, k, l, 2, 3, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (32);
Epsilon (j,2);
Epsilon (j,3);
Push (Integer (-8));
Push (Minor3 (i, k, l, 1, 2, 0));
Push (Minor3 (i, k, l, 1, 3, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (33);
Epsilon (j,2);
Epsilon (j,3);
Epsilon (i,2);
Push (Integer (8));
Push (Minor2 (k, l, 1, 0));
Push (Minor3 (i, k, l, 1, 3, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (34);
Epsilon (j,2);
Epsilon (j,3);
Epsilon (i,1);
Push (Integer (-8));
Push (Minor2 (k, l, 3, 0));
Push (Minor3 (i, k, l, 1, 2, 0));
Times ();
Push (Minor2 (k, l, 2, 0));
Push (Minor3 (i, k, l, 1, 3, 0));
Times ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (35);
Epsilon (j,2);
Epsilon (j,3);
Epsilon (i,1);
Epsilon (i,2);
Push (Integer (8));
Push (Minor2 (k, l, 1, 0));
Push (Minor2 (k, l, 3, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (36);
Epsilon (j,2);
Epsilon (j,3);
Epsilon (i,1);
Epsilon (i,1);
Push (Integer (-8));
Push (Minor2 (k, l, 2, 0));
Push (Minor2 (k, l, 3, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (37);
Epsilon (j,2);
Epsilon (j,2);
Push (Integer (4));
Push (Minor3 (i, k, l, 1, 3, 0));
Push (Integer (2));
Power ();
Times ();
Coefficient (Pop ());
Epsilon_Term (38);
Epsilon (j,2);
Epsilon (j,2);
Epsilon (i,1);
Push (Integer (8));
Push (Minor2 (k, l, 3, 0));
Push (Minor3 (i, k, l, 1, 3, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (39);
Epsilon (j,2);
Epsilon (j,2);
Epsilon (i,1);
Epsilon (i,1);
Push (Integer (4));
Push (Minor2 (k, l, 3, 0));
Push (Integer (2));
Power ();
Times ();
Coefficient (Pop ());
Epsilon_Term (40);
Epsilon (j,1);
Push (Integer (-8));
Push (Minor3 (i, k, l, 2, 3, 0));
Push (Minor4 (i, j, k, l, 1, 2, 3, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (41);
Epsilon (j,1);
Epsilon (i,3);
Push (Integer (-8));
Push (Minor3 (i, k, l, 2, 3, 0));
Push (Minor3 (j, k, l, 1, 2, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (42);
Epsilon (j,1);
Epsilon (i,2);
Push (Integer (8));
Push (Minor3 (i, k, l, 2, 3, 0));
Push (Minor3 (j, k, l, 1, 3, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (43);
Epsilon (j,1);
Epsilon (i,1);
Push (Integer (-8));
Push (Minor3 (i, k, l, 2, 3, 0));
Push (Minor3 (j, k, l, 2, 3, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (44);
Epsilon (j,1);
Epsilon (j,3);
Push (Integer (8));
Push (Minor3 (i, k, l, 1, 2, 0));
Push (Minor3 (i, k, l, 2, 3, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (45);
Epsilon (j,1);
Epsilon (j,3);
Epsilon (i,2);
Push (Integer (-8));
Push (Minor2 (k, l, 1, 0));
Push (Minor3 (i, k, l, 2, 3, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (46);
Epsilon (j,1);
Epsilon (j,3);
Epsilon (i,1);
Push (Integer (8));
Push (Minor2 (k, l, 2, 0));
Push (Minor3 (i, k, l, 2, 3, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (47);
Epsilon (j,1);
Epsilon (j,2);
Push (Integer (-8));
Push (Minor3 (i, k, l, 1, 3, 0));
Push (Minor3 (i, k, l, 2, 3, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (48);
Epsilon (j,1);
Epsilon (j,2);
Epsilon (i,1);
Push (Integer (-8));
Push (Minor2 (k, l, 3, 0));
Push (Minor3 (i, k, l, 2, 3, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (49);
Epsilon (j,1);
Epsilon (j,1);
Push (Integer (4));
Push (Minor3 (i, k, l, 2, 3, 0));
Push (Integer (2));
Power ();
Times ();
Coefficient (Pop ());
Epsilon_Term (50);
Epsilon (k,3);
Push (Integer (8));
Push (Minor3 (i, j, l, 1, 2, 0));
Push (Minor4 (i, j, k, l, 1, 2, 3, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (51);
Epsilon (k,3);
Epsilon (i,3);
Push (Integer (8));
Push (Minor3 (i, j, l, 1, 2, 0));
Push (Minor3 (j, k, l, 1, 2, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (52);
Epsilon (k,3);
Epsilon (i,2);
Push (Integer (-8));
Push (Minor3 (i, j, l, 1, 2, 0));
Push (Minor3 (j, k, l, 1, 3, 0));
Times ();
Push (Minor2 (j, l, 1, 0));
Push (Minor4 (i, j, k, l, 1, 2, 3, 0));
Times ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (53);
Epsilon (k,3);
Epsilon (i,2);
Epsilon (i,3);
Push (Integer (-8));
Push (Minor2 (j, l, 1, 0));
Push (Minor3 (j, k, l, 1, 2, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (54);
Epsilon (k,3);
Epsilon (i,2);
Epsilon (i,2);
Push (Integer (8));
Push (Minor2 (j, l, 1, 0));
Push (Minor3 (j, k, l, 1, 3, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (55);
Epsilon (k,3);
Epsilon (i,1);
Push (Integer (8));
Push (Minor3 (i, j, l, 1, 2, 0));
Push (Minor3 (j, k, l, 2, 3, 0));
Times ();
Push (Minor2 (j, l, 2, 0));
Push (Minor4 (i, j, k, l, 1, 2, 3, 0));
Times ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (56);
Epsilon (k,3);
Epsilon (i,1);
Epsilon (i,3);
Push (Integer (8));
Push (Minor2 (j, l, 2, 0));
Push (Minor3 (j, k, l, 1, 2, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (57);
Epsilon (k,3);
Epsilon (i,1);
Epsilon (i,2);
Push (Integer (-8));
Push (Minor2 (j, l, 2, 0));
Push (Minor3 (j, k, l, 1, 3, 0));
Times ();
Push (Minor2 (j, l, 1, 0));
Push (Minor3 (j, k, l, 2, 3, 0));
Times ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (58);
Epsilon (k,3);
Epsilon (i,1);
Epsilon (i,1);
Push (Integer (8));
Push (Minor2 (j, l, 2, 0));
Push (Minor3 (j, k, l, 2, 3, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (59);
Epsilon (k,3);
Epsilon (j,3);
Push (Integer (-8));
Push (Minor3 (i, j, l, 1, 2, 0));
Push (Minor3 (i, k, l, 1, 2, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (60);
Epsilon (k,3);
Epsilon (j,3);
Epsilon (i,2);
Push (Integer (8));
Push (Minor2 (k, l, 1, 0));
Push (Minor3 (i, j, l, 1, 2, 0));
Times ();
Push (Minor2 (j, l, 1, 0));
Push (Minor3 (i, k, l, 1, 2, 0));
Times ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (61);
Epsilon (k,3);
Epsilon (j,3);
Epsilon (i,2);
Epsilon (i,2);
Push (Integer (-8));
Push (Minor2 (j, l, 1, 0));
Push (Minor2 (k, l, 1, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (62);
Epsilon (k,3);
Epsilon (j,3);
Epsilon (i,1);
Push (Integer (-8));
Push (Minor2 (k, l, 2, 0));
Push (Minor3 (i, j, l, 1, 2, 0));
Times ();
Push (Minor2 (j, l, 2, 0));
Push (Minor3 (i, k, l, 1, 2, 0));
Times ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (63);
Epsilon (k,3);
Epsilon (j,3);
Epsilon (i,1);
Epsilon (i,2);
Push (Integer (8));
Push (Minor2 (j, l, 2, 0));
Push (Minor2 (k, l, 1, 0));
Times ();
Push (Minor2 (j, l, 1, 0));
Push (Minor2 (k, l, 2, 0));
Times ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (64);
Epsilon (k,3);
Epsilon (j,3);
Epsilon (i,1);
Epsilon (i,1);
Push (Integer (-8));
Push (Minor2 (j, l, 2, 0));
Push (Minor2 (k, l, 2, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (65);
Epsilon (k,3);
Epsilon (j,2);
Push (Integer (8));
Push (Minor3 (i, j, l, 1, 2, 0));
Push (Minor3 (i, k, l, 1, 3, 0));
Times ();
Push (Minor2 (i, l, 1, 0));
Push (Minor4 (i, j, k, l, 1, 2, 3, 0));
Times ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (66);
Epsilon (k,3);
Epsilon (j,2);
Epsilon (i,3);
Push (Integer (8));
Push (Minor2 (i, l, 1, 0));
Push (Minor3 (j, k, l, 1, 2, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (67);
Epsilon (k,3);
Epsilon (j,2);
Epsilon (i,2);
Push (Integer (-8));
Push (Minor2 (j, l, 1, 0));
Push (Minor3 (i, k, l, 1, 3, 0));
Times ();
Push (Minor2 (i, l, 1, 0));
Push (Minor3 (j, k, l, 1, 3, 0));
Times ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (68);
Epsilon (k,3);
Epsilon (j,2);
Epsilon (i,1);
Push (Integer (8));
Push (Minor2 (k, l, 3, 0));
Push (Minor3 (i, j, l, 1, 2, 0));
Times ();
Push (Minor2 (j, l, 2, 0));
Push (Minor3 (i, k, l, 1, 3, 0));
Times ();
Push (Minor2 (i, l, 1, 0));
Push (Minor3 (j, k, l, 2, 3, 0));
Times ();
Push (Minor4 (i, j, k, l, 1, 2, 3, 0));
Plus ();
Plus ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (69);
Epsilon (k,3);
Epsilon (j,2);
Epsilon (i,1);
Epsilon (i,3);
Push (Integer (8));
Push (Minor3 (j, k, l, 1, 2, 0));
Times ();
Coefficient (Pop ());
Epsilon_Term (70);
Epsilon (k,3);
Epsilon (j,2);
Epsilon (i,1);
Epsilon (i,2);
Push (Integer (-8));
Push (Minor2 (j, l, 1, 0));
Push (Minor2 (k, l, 3, 0));
Times ();
Push (Minor3 (j, k, l, 1, 3, 0));
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (71);
Epsilon (k,3);
Epsilon (j,2);
Epsilon (i,1);
Epsilon (i,1);
Push (Integer (8));
Push (Minor2 (j, l, 2, 0));
Push (Minor2 (k, l, 3, 0));
Times ();
Push (Minor3 (j, k, l, 2, 3, 0));
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (72);
Epsilon (k,3);
Epsilon (j,2);
Epsilon (j,3);
Push (Integer (-8));
Push (Minor2 (i, l, 1, 0));
Push (Minor3 (i, k, l, 1, 2, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (73);
Epsilon (k,3);
Epsilon (j,2);
Epsilon (j,3);
Epsilon (i,2);
Push (Integer (8));
Push (Minor2 (i, l, 1, 0));
Push (Minor2 (k, l, 1, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (74);
Epsilon (k,3);
Epsilon (j,2);
Epsilon (j,3);
Epsilon (i,1);
Push (Integer (-8));
Push (Minor2 (i, l, 1, 0));
Push (Minor2 (k, l, 2, 0));
Times ();
Push (Minor3 (i, k, l, 1, 2, 0));
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (75);
Epsilon (k,3);
Epsilon (j,2);
Epsilon (j,3);
Epsilon (i,1);
Epsilon (i,2);
Push (Integer (8));
Push (Minor2 (k, l, 1, 0));
Times ();
Coefficient (Pop ());
Epsilon_Term (76);
Epsilon (k,3);
Epsilon (j,2);
Epsilon (j,3);
Epsilon (i,1);
Epsilon (i,1);
Push (Integer (-8));
Push (Minor2 (k, l, 2, 0));
Times ();
Coefficient (Pop ());
Epsilon_Term (77);
Epsilon (k,3);
Epsilon (j,2);
Epsilon (j,2);
Push (Integer (8));
Push (Minor2 (i, l, 1, 0));
Push (Minor3 (i, k, l, 1, 3, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (78);
Epsilon (k,3);
Epsilon (j,2);
Epsilon (j,2);
Epsilon (i,1);
Push (Integer (8));
Push (Minor2 (i, l, 1, 0));
Push (Minor2 (k, l, 3, 0));
Times ();
Push (Minor3 (i, k, l, 1, 3, 0));
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (79);
Epsilon (k,3);
Epsilon (j,2);
Epsilon (j,2);
Epsilon (i,1);
Epsilon (i,1);
Push (Integer (8));
Push (Minor2 (k, l, 3, 0));
Times ();
Coefficient (Pop ());
Epsilon_Term (80);
Epsilon (k,3);
Epsilon (j,1);
Push (Integer (-8));
Push (Minor3 (i, j, l, 1, 2, 0));
Push (Minor3 (i, k, l, 2, 3, 0));
Times ();
Push (Minor2 (i, l, 2, 0));
Push (Minor4 (i, j, k, l, 1, 2, 3, 0));
Times ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (81);
Epsilon (k,3);
Epsilon (j,1);
Epsilon (i,3);
Push (Integer (-8));
Push (Minor2 (i, l, 2, 0));
Push (Minor3 (j, k, l, 1, 2, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (82);
Epsilon (k,3);
Epsilon (j,1);
Epsilon (i,2);
Push (Integer (8));
Push (Minor2 (j, l, 1, 0));
Push (Minor3 (i, k, l, 2, 3, 0));
Times ();
Push (Minor2 (i, l, 2, 0));
Push (Minor3 (j, k, l, 1, 3, 0));
Times ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (83);
Epsilon (k,3);
Epsilon (j,1);
Epsilon (i,1);
Push (Integer (-8));
Push (Minor2 (j, l, 2, 0));
Push (Minor3 (i, k, l, 2, 3, 0));
Times ();
Push (Minor2 (i, l, 2, 0));
Push (Minor3 (j, k, l, 2, 3, 0));
Times ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (84);
Epsilon (k,3);
Epsilon (j,1);
Epsilon (j,3);
Push (Integer (8));
Push (Minor2 (i, l, 2, 0));
Push (Minor3 (i, k, l, 1, 2, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (85);
Epsilon (k,3);
Epsilon (j,1);
Epsilon (j,3);
Epsilon (i,2);
Push (Integer (-8));
Push (Minor2 (i, l, 2, 0));
Push (Minor2 (k, l, 1, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (86);
Epsilon (k,3);
Epsilon (j,1);
Epsilon (j,3);
Epsilon (i,1);
Push (Integer (8));
Push (Minor2 (i, l, 2, 0));
Push (Minor2 (k, l, 2, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (87);
Epsilon (k,3);
Epsilon (j,1);
Epsilon (j,2);
Push (Integer (-8));
Push (Minor2 (i, l, 2, 0));
Push (Minor3 (i, k, l, 1, 3, 0));
Times ();
Push (Minor2 (i, l, 1, 0));
Push (Minor3 (i, k, l, 2, 3, 0));
Times ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (88);
Epsilon (k,3);
Epsilon (j,1);
Epsilon (j,2);
Epsilon (i,1);
Push (Integer (-8));
Push (Minor2 (i, l, 2, 0));
Push (Minor2 (k, l, 3, 0));
Times ();
Push (Minor3 (i, k, l, 2, 3, 0));
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (89);
Epsilon (k,3);
Epsilon (j,1);
Epsilon (j,1);
Push (Integer (8));
Push (Minor2 (i, l, 2, 0));
Push (Minor3 (i, k, l, 2, 3, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (90);
Epsilon (k,3);
Epsilon (k,3);
Push (Integer (4));
Push (Minor3 (i, j, l, 1, 2, 0));
Push (Integer (2));
Power ();
Times ();
Coefficient (Pop ());
Epsilon_Term (91);
Epsilon (k,3);
Epsilon (k,3);
Epsilon (i,2);
Push (Integer (-8));
Push (Minor2 (j, l, 1, 0));
Push (Minor3 (i, j, l, 1, 2, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (92);
Epsilon (k,3);
Epsilon (k,3);
Epsilon (i,2);
Epsilon (i,2);
Push (Integer (4));
Push (Minor2 (j, l, 1, 0));
Push (Integer (2));
Power ();
Times ();
Coefficient (Pop ());
Epsilon_Term (93);
Epsilon (k,3);
Epsilon (k,3);
Epsilon (i,1);
Push (Integer (8));
Push (Minor2 (j, l, 2, 0));
Push (Minor3 (i, j, l, 1, 2, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (94);
Epsilon (k,3);
Epsilon (k,3);
Epsilon (i,1);
Epsilon (i,2);
Push (Integer (-8));
Push (Minor2 (j, l, 1, 0));
Push (Minor2 (j, l, 2, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (95);
Epsilon (k,3);
Epsilon (k,3);
Epsilon (i,1);
Epsilon (i,1);
Push (Integer (4));
Push (Minor2 (j, l, 2, 0));
Push (Integer (2));
Power ();
Times ();
Coefficient (Pop ());
Epsilon_Term (96);
Epsilon (k,3);
Epsilon (k,3);
Epsilon (j,2);
Push (Integer (8));
Push (Minor2 (i, l, 1, 0));
Push (Minor3 (i, j, l, 1, 2, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (97);
Epsilon (k,3);
Epsilon (k,3);
Epsilon (j,2);
Epsilon (i,2);
Push (Integer (-8));
Push (Minor2 (i, l, 1, 0));
Push (Minor2 (j, l, 1, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (98);
Epsilon (k,3);
Epsilon (k,3);
Epsilon (j,2);
Epsilon (i,1);
Push (Integer (8));
Push (Minor2 (i, l, 1, 0));
Push (Minor2 (j, l, 2, 0));
Times ();
Push (Minor3 (i, j, l, 1, 2, 0));
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (99);
Epsilon (k,3);
Epsilon (k,3);
Epsilon (j,2);
Epsilon (i,1);
Epsilon (i,2);
Push (Integer (-8));
Push (Minor2 (j, l, 1, 0));
Times ();
Coefficient (Pop ());
Epsilon_Term (100);
Epsilon (k,3);
Epsilon (k,3);
Epsilon (j,2);
Epsilon (i,1);
Epsilon (i,1);
Push (Integer (8));
Push (Minor2 (j, l, 2, 0));
Times ();
Coefficient (Pop ());
Epsilon_Term (101);
Epsilon (k,3);
Epsilon (k,3);
Epsilon (j,2);
Epsilon (j,2);
Push (Integer (4));
Push (Minor2 (i, l, 1, 0));
Push (Integer (2));
Power ();
Times ();
Coefficient (Pop ());
Epsilon_Term (102);
Epsilon (k,3);
Epsilon (k,3);
Epsilon (j,2);
Epsilon (j,2);
Epsilon (i,1);
Push (Integer (8));
Push (Minor2 (i, l, 1, 0));
Times ();
Coefficient (Pop ());
Epsilon_Term (103);
Epsilon (k,3);
Epsilon (k,3);
Epsilon (j,2);
Epsilon (j,2);
Epsilon (i,1);
Epsilon (i,1);
Push (Integer (4));
Coefficient (Pop ());
Finish ();
}

#endif  /* #if !defined(lint) */
