/* sos/rho3_num.c */

#if !defined(lint)  /* lint takes forever! */

/*--------------------------------------------------------------------------*/

#include "geom/basic.h"
#include "geom/sos.h"
#include "internal.h"
#include "primitive.h"

/*--------------------------------------------------------------------------*/

Static_Declarations ("rho3_num", 4, 213, 6);

#include "../sos/primitive.i.c"

/*--------------------------------------------------------------------------*/

SoS_primitive_result * sos_rho3_num (i, j, k, l)
     int i, j, k, l;
     /* returns significant term of Rho3 numerator */
{
#ifdef __DEBUG__
  if (sos_proto_e_flag)
    {
      lia_clear ();
      print ("sos_rho3_num (%d,%d,%d,%d)", i, j, k, l);
      print (" (");
      print ("%s,%s,%s,%s;", Pi(i,1), Pi(i,2), Pi(i,3), Pi(i,4));
      print ("%s,%s,%s,%s;", Pi(j,1), Pi(j,2), Pi(j,3), Pi(j,4));
      print ("%s,%s,%s,%s;", Pi(k,1), Pi(k,2), Pi(k,3), Pi(k,4));
      print ("%s,%s,%s,%s;", Pi(l,1), Pi(l,2), Pi(l,3), Pi(l,4));
      print (")\n");
    }
#endif
/* C code generated by 'ccode' from 'gee' file "Rho3.num" */
Initialize ();
Epsilon_Term (0);
Push (Integer (4));
Push (Minor4 (i, j, k, l, 1, 2, 3, 0));
Push (Minor4 (i, j, k, l, 1, 2, 3, 4));
Times ();
Times ();
Push (Minor4 (i, j, k, l, 1, 2, 4, 0));
Push (Integer (2));
Power ();
Push (Minor4 (i, j, k, l, 1, 3, 4, 0));
Push (Integer (2));
Power ();
Push (Minor4 (i, j, k, l, 2, 3, 4, 0));
Push (Integer (2));
Power ();
Plus ();
Plus ();
Plus ();
Coefficient (Pop ());
Epsilon_Term (1);
Epsilon (i,4);
Push (Integer (2));
Push (Integer (-2));
Push (Minor3 (j, k, l, 1, 2, 3));
Push (Minor4 (i, j, k, l, 1, 2, 3, 0));
Times ();
Times ();
Push (Minor3 (j, k, l, 1, 2, 0));
Push (Minor4 (i, j, k, l, 1, 2, 4, 0));
Times ();
Push (Minor3 (j, k, l, 1, 3, 0));
Push (Minor4 (i, j, k, l, 1, 3, 4, 0));
Times ();
Push (Minor3 (j, k, l, 2, 3, 0));
Push (Minor4 (i, j, k, l, 2, 3, 4, 0));
Times ();
Plus ();
Plus ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (2);
Epsilon (i,4);
Epsilon (i,4);
Push (Minor3 (j, k, l, 1, 2, 0));
Push (Integer (2));
Power ();
Push (Minor3 (j, k, l, 1, 3, 0));
Push (Integer (2));
Power ();
Push (Minor3 (j, k, l, 2, 3, 0));
Push (Integer (2));
Power ();
Plus ();
Plus ();
Coefficient (Pop ());
Epsilon_Term (3);
Epsilon (i,3);
Push (Integer (4));
Push (Minor3 (j, k, l, 1, 2, 4));
Push (Minor4 (i, j, k, l, 1, 2, 3, 0));
Times ();
Times ();
Push (Integer (4));
Push (Minor3 (j, k, l, 1, 2, 0));
Push (Minor4 (i, j, k, l, 1, 2, 3, 4));
Times ();
Times ();
Push (Integer (2));
Push (Minor3 (j, k, l, 1, 4, 0));
Push (Minor4 (i, j, k, l, 1, 3, 4, 0));
Times ();
Times ();
Push (Integer (2));
Push (Minor3 (j, k, l, 2, 4, 0));
Push (Minor4 (i, j, k, l, 2, 3, 4, 0));
Times ();
Times ();
Minus ();
Minus ();
Plus ();
Coefficient (Pop ());
Epsilon_Term (4);
Epsilon (i,3);
Epsilon (i,4);
Push (Integer (-2));
Push (Integer (2));
Push (Minor3 (j, k, l, 1, 2, 0));
Push (Minor3 (j, k, l, 1, 2, 3));
Times ();
Times ();
Push (Minor3 (j, k, l, 1, 3, 0));
Push (Minor3 (j, k, l, 1, 4, 0));
Times ();
Push (Minor3 (j, k, l, 2, 3, 0));
Push (Minor3 (j, k, l, 2, 4, 0));
Times ();
Plus ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (5);
Epsilon (i,3);
Epsilon (i,3);
Push (Integer (4));
Push (Minor3 (j, k, l, 1, 2, 0));
Push (Minor3 (j, k, l, 1, 2, 4));
Times ();
Times ();
Push (Minor3 (j, k, l, 1, 4, 0));
Push (Integer (2));
Power ();
Push (Minor3 (j, k, l, 2, 4, 0));
Push (Integer (2));
Power ();
Plus ();
Plus ();
Coefficient (Pop ());
Epsilon_Term (6);
Epsilon (i,2);
Push (Integer (2));
Push (Integer (-2));
Push (Minor3 (j, k, l, 1, 3, 4));
Push (Minor4 (i, j, k, l, 1, 2, 3, 0));
Times ();
Times ();
Push (Integer (2));
Push (Minor3 (j, k, l, 1, 3, 0));
Push (Minor4 (i, j, k, l, 1, 2, 3, 4));
Times ();
Times ();
Push (Minor3 (j, k, l, 1, 4, 0));
Push (Minor4 (i, j, k, l, 1, 2, 4, 0));
Times ();
Push (Minor3 (j, k, l, 3, 4, 0));
Push (Minor4 (i, j, k, l, 2, 3, 4, 0));
Times ();
Plus ();
Minus ();
Minus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (7);
Epsilon (i,2);
Epsilon (i,4);
Push (Integer (2));
Push (Integer (2));
Push (Minor3 (j, k, l, 1, 2, 3));
Push (Minor3 (j, k, l, 1, 3, 0));
Times ();
Times ();
Push (Minor3 (j, k, l, 1, 2, 0));
Push (Minor3 (j, k, l, 1, 4, 0));
Times ();
Push (Minor3 (j, k, l, 2, 3, 0));
Push (Minor3 (j, k, l, 3, 4, 0));
Times ();
Plus ();
Minus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (8);
Epsilon (i,2);
Epsilon (i,3);
Push (Integer (-4));
Push (Minor3 (j, k, l, 1, 2, 4));
Push (Minor3 (j, k, l, 1, 3, 0));
Times ();
Times ();
Push (Integer (4));
Push (Minor3 (j, k, l, 1, 2, 0));
Push (Minor3 (j, k, l, 1, 3, 4));
Times ();
Times ();
Push (Integer (2));
Push (Minor3 (j, k, l, 2, 4, 0));
Push (Minor3 (j, k, l, 3, 4, 0));
Times ();
Times ();
Minus ();
Minus ();
Coefficient (Pop ());
Epsilon_Term (9);
Epsilon (i,2);
Epsilon (i,2);
Push (Integer (4));
Push (Minor3 (j, k, l, 1, 3, 0));
Push (Minor3 (j, k, l, 1, 3, 4));
Times ();
Times ();
Push (Minor3 (j, k, l, 1, 4, 0));
Push (Integer (2));
Power ();
Push (Minor3 (j, k, l, 3, 4, 0));
Push (Integer (2));
Power ();
Plus ();
Plus ();
Coefficient (Pop ());
Epsilon_Term (10);
Epsilon (i,1);
Push (Integer (2));
Push (Integer (2));
Push (Minor3 (j, k, l, 2, 3, 4));
Push (Minor4 (i, j, k, l, 1, 2, 3, 0));
Times ();
Times ();
Push (Integer (2));
Push (Minor3 (j, k, l, 2, 3, 0));
Push (Minor4 (i, j, k, l, 1, 2, 3, 4));
Times ();
Times ();
Push (Minor3 (j, k, l, 2, 4, 0));
Push (Minor4 (i, j, k, l, 1, 2, 4, 0));
Times ();
Push (Minor3 (j, k, l, 3, 4, 0));
Push (Minor4 (i, j, k, l, 1, 3, 4, 0));
Times ();
Plus ();
Plus ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (11);
Epsilon (i,1);
Epsilon (i,4);
Push (Integer (2));
Push (Integer (-2));
Push (Minor3 (j, k, l, 1, 2, 3));
Push (Minor3 (j, k, l, 2, 3, 0));
Times ();
Times ();
Push (Minor3 (j, k, l, 1, 2, 0));
Push (Minor3 (j, k, l, 2, 4, 0));
Times ();
Push (Minor3 (j, k, l, 1, 3, 0));
Push (Minor3 (j, k, l, 3, 4, 0));
Times ();
Plus ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (12);
Epsilon (i,1);
Epsilon (i,3);
Push (Integer (4));
Push (Minor3 (j, k, l, 1, 2, 4));
Push (Minor3 (j, k, l, 2, 3, 0));
Times ();
Times ();
Push (Integer (4));
Push (Minor3 (j, k, l, 1, 2, 0));
Push (Minor3 (j, k, l, 2, 3, 4));
Times ();
Times ();
Push (Integer (2));
Push (Minor3 (j, k, l, 1, 4, 0));
Push (Minor3 (j, k, l, 3, 4, 0));
Times ();
Times ();
Minus ();
Plus ();
Coefficient (Pop ());
Epsilon_Term (13);
Epsilon (i,1);
Epsilon (i,2);
Push (Integer (-4));
Push (Minor3 (j, k, l, 1, 3, 4));
Push (Minor3 (j, k, l, 2, 3, 0));
Times ();
Times ();
Push (Integer (4));
Push (Minor3 (j, k, l, 1, 3, 0));
Push (Minor3 (j, k, l, 2, 3, 4));
Times ();
Times ();
Push (Integer (2));
Push (Minor3 (j, k, l, 1, 4, 0));
Push (Minor3 (j, k, l, 2, 4, 0));
Times ();
Times ();
Minus ();
Minus ();
Coefficient (Pop ());
Epsilon_Term (14);
Epsilon (i,1);
Epsilon (i,1);
Push (Integer (4));
Push (Minor3 (j, k, l, 2, 3, 0));
Push (Minor3 (j, k, l, 2, 3, 4));
Times ();
Times ();
Push (Minor3 (j, k, l, 2, 4, 0));
Push (Integer (2));
Power ();
Push (Minor3 (j, k, l, 3, 4, 0));
Push (Integer (2));
Power ();
Plus ();
Plus ();
Coefficient (Pop ());
Epsilon_Term (15);
Epsilon (j,4);
Push (Integer (2));
Push (Integer (2));
Push (Minor3 (i, k, l, 1, 2, 3));
Push (Minor4 (i, j, k, l, 1, 2, 3, 0));
Times ();
Times ();
Push (Minor3 (i, k, l, 1, 2, 0));
Push (Minor4 (i, j, k, l, 1, 2, 4, 0));
Times ();
Push (Minor3 (i, k, l, 1, 3, 0));
Push (Minor4 (i, j, k, l, 1, 3, 4, 0));
Times ();
Push (Minor3 (i, k, l, 2, 3, 0));
Push (Minor4 (i, j, k, l, 2, 3, 4, 0));
Times ();
Minus ();
Minus ();
Minus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (16);
Epsilon (j,4);
Epsilon (i,4);
Push (Integer (-2));
Push (Minor3 (i, k, l, 1, 2, 0));
Push (Minor3 (j, k, l, 1, 2, 0));
Times ();
Push (Minor3 (i, k, l, 1, 3, 0));
Push (Minor3 (j, k, l, 1, 3, 0));
Times ();
Push (Minor3 (i, k, l, 2, 3, 0));
Push (Minor3 (j, k, l, 2, 3, 0));
Times ();
Plus ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (17);
Epsilon (j,4);
Epsilon (i,3);
Push (Integer (2));
Push (Integer (2));
Push (Minor3 (i, k, l, 1, 2, 3));
Push (Minor3 (j, k, l, 1, 2, 0));
Times ();
Times ();
Push (Minor3 (i, k, l, 1, 3, 0));
Push (Minor3 (j, k, l, 1, 4, 0));
Times ();
Push (Minor3 (i, k, l, 2, 3, 0));
Push (Minor3 (j, k, l, 2, 4, 0));
Times ();
Push (Integer (2));
Push (Minor2 (k, l, 1, 2));
Push (Minor4 (i, j, k, l, 1, 2, 3, 0));
Times ();
Times ();
Push (Minor2 (k, l, 1, 0));
Push (Minor4 (i, j, k, l, 1, 3, 4, 0));
Times ();
Push (Minor2 (k, l, 2, 0));
Push (Minor4 (i, j, k, l, 2, 3, 4, 0));
Times ();
Plus ();
Plus ();
Plus ();
Plus ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (18);
Epsilon (j,4);
Epsilon (i,3);
Epsilon (i,4);
Push (Integer (2));
Push (Minor2 (k, l, 1, 0));
Push (Minor3 (j, k, l, 1, 3, 0));
Times ();
Push (Minor2 (k, l, 2, 0));
Push (Minor3 (j, k, l, 2, 3, 0));
Times ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (19);
Epsilon (j,4);
Epsilon (i,3);
Epsilon (i,3);
Push (Integer (4));
Push (Minor2 (k, l, 1, 2));
Push (Minor3 (j, k, l, 1, 2, 0));
Times ();
Times ();
Push (Integer (2));
Push (Minor2 (k, l, 1, 0));
Push (Minor3 (j, k, l, 1, 4, 0));
Times ();
Times ();
Push (Integer (2));
Push (Minor2 (k, l, 2, 0));
Push (Minor3 (j, k, l, 2, 4, 0));
Times ();
Times ();
Minus ();
Minus ();
Coefficient (Pop ());
Epsilon_Term (20);
Epsilon (j,4);
Epsilon (i,2);
Push (Integer (2));
Push (Integer (-2));
Push (Minor3 (i, k, l, 1, 2, 3));
Push (Minor3 (j, k, l, 1, 3, 0));
Times ();
Times ();
Push (Minor3 (i, k, l, 1, 2, 0));
Push (Minor3 (j, k, l, 1, 4, 0));
Times ();
Push (Minor3 (i, k, l, 2, 3, 0));
Push (Minor3 (j, k, l, 3, 4, 0));
Times ();
Push (Integer (2));
Push (Minor2 (k, l, 1, 3));
Push (Minor4 (i, j, k, l, 1, 2, 3, 0));
Times ();
Times ();
Push (Minor2 (k, l, 1, 0));
Push (Minor4 (i, j, k, l, 1, 2, 4, 0));
Times ();
Push (Minor2 (k, l, 3, 0));
Push (Minor4 (i, j, k, l, 2, 3, 4, 0));
Times ();
Minus ();
Plus ();
Minus ();
Minus ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (21);
Epsilon (j,4);
Epsilon (i,2);
Epsilon (i,4);
Push (Integer (2));
Push (Minor2 (k, l, 1, 0));
Push (Minor3 (j, k, l, 1, 2, 0));
Times ();
Push (Minor2 (k, l, 3, 0));
Push (Minor3 (j, k, l, 2, 3, 0));
Times ();
Minus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (22);
Epsilon (j,4);
Epsilon (i,2);
Epsilon (i,3);
Push (Integer (2));
Push (Integer (-2));
Push (Minor2 (k, l, 1, 3));
Push (Minor3 (j, k, l, 1, 2, 0));
Times ();
Times ();
Push (Integer (2));
Push (Minor2 (k, l, 1, 2));
Push (Minor3 (j, k, l, 1, 3, 0));
Times ();
Times ();
Push (Minor2 (k, l, 3, 0));
Push (Minor3 (j, k, l, 2, 4, 0));
Times ();
Push (Minor2 (k, l, 2, 0));
Push (Minor3 (j, k, l, 3, 4, 0));
Times ();
Plus ();
Plus ();
Minus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (23);
Epsilon (j,4);
Epsilon (i,2);
Epsilon (i,2);
Push (Integer (4));
Push (Minor2 (k, l, 1, 3));
Push (Minor3 (j, k, l, 1, 3, 0));
Times ();
Times ();
Push (Integer (2));
Push (Minor2 (k, l, 1, 0));
Push (Minor3 (j, k, l, 1, 4, 0));
Times ();
Times ();
Push (Integer (2));
Push (Minor2 (k, l, 3, 0));
Push (Minor3 (j, k, l, 3, 4, 0));
Times ();
Times ();
Minus ();
Minus ();
Coefficient (Pop ());
Epsilon_Term (24);
Epsilon (j,4);
Epsilon (i,1);
Push (Integer (2));
Push (Integer (2));
Push (Minor3 (i, k, l, 1, 2, 3));
Push (Minor3 (j, k, l, 2, 3, 0));
Times ();
Times ();
Push (Minor3 (i, k, l, 1, 2, 0));
Push (Minor3 (j, k, l, 2, 4, 0));
Times ();
Push (Minor3 (i, k, l, 1, 3, 0));
Push (Minor3 (j, k, l, 3, 4, 0));
Times ();
Push (Integer (2));
Push (Minor2 (k, l, 2, 3));
Push (Minor4 (i, j, k, l, 1, 2, 3, 0));
Times ();
Times ();
Push (Minor2 (k, l, 2, 0));
Push (Minor4 (i, j, k, l, 1, 2, 4, 0));
Times ();
Push (Minor2 (k, l, 3, 0));
Push (Minor4 (i, j, k, l, 1, 3, 4, 0));
Times ();
Minus ();
Minus ();
Plus ();
Minus ();
Minus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (25);
Epsilon (j,4);
Epsilon (i,1);
Epsilon (i,4);
Push (Integer (-2));
Push (Minor2 (k, l, 2, 0));
Push (Minor3 (j, k, l, 1, 2, 0));
Times ();
Push (Minor2 (k, l, 3, 0));
Push (Minor3 (j, k, l, 1, 3, 0));
Times ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (26);
Epsilon (j,4);
Epsilon (i,1);
Epsilon (i,3);
Push (Integer (2));
Push (Integer (2));
Push (Minor2 (k, l, 2, 3));
Push (Minor3 (j, k, l, 1, 2, 0));
Times ();
Times ();
Push (Minor2 (k, l, 3, 0));
Push (Minor3 (j, k, l, 1, 4, 0));
Times ();
Push (Integer (2));
Push (Minor2 (k, l, 1, 2));
Push (Minor3 (j, k, l, 2, 3, 0));
Times ();
Times ();
Push (Minor2 (k, l, 1, 0));
Push (Minor3 (j, k, l, 3, 4, 0));
Times ();
Plus ();
Plus ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (27);
Epsilon (j,4);
Epsilon (i,1);
Epsilon (i,2);
Push (Integer (2));
Push (Integer (-2));
Push (Minor2 (k, l, 2, 3));
Push (Minor3 (j, k, l, 1, 3, 0));
Times ();
Times ();
Push (Minor2 (k, l, 2, 0));
Push (Minor3 (j, k, l, 1, 4, 0));
Times ();
Push (Integer (2));
Push (Minor2 (k, l, 1, 3));
Push (Minor3 (j, k, l, 2, 3, 0));
Times ();
Times ();
Push (Minor2 (k, l, 1, 0));
Push (Minor3 (j, k, l, 2, 4, 0));
Times ();
Plus ();
Minus ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (28);
Epsilon (j,4);
Epsilon (i,1);
Epsilon (i,1);
Push (Integer (4));
Push (Minor2 (k, l, 2, 3));
Push (Minor3 (j, k, l, 2, 3, 0));
Times ();
Times ();
Push (Integer (2));
Push (Minor2 (k, l, 2, 0));
Push (Minor3 (j, k, l, 2, 4, 0));
Times ();
Times ();
Push (Integer (2));
Push (Minor2 (k, l, 3, 0));
Push (Minor3 (j, k, l, 3, 4, 0));
Times ();
Times ();
Minus ();
Minus ();
Coefficient (Pop ());
Epsilon_Term (29);
Epsilon (j,4);
Epsilon (j,4);
Push (Minor3 (i, k, l, 1, 2, 0));
Push (Integer (2));
Power ();
Push (Minor3 (i, k, l, 1, 3, 0));
Push (Integer (2));
Power ();
Push (Minor3 (i, k, l, 2, 3, 0));
Push (Integer (2));
Power ();
Plus ();
Plus ();
Coefficient (Pop ());
Epsilon_Term (30);
Epsilon (j,4);
Epsilon (j,4);
Epsilon (i,3);
Push (Integer (-2));
Push (Minor2 (k, l, 1, 0));
Push (Minor3 (i, k, l, 1, 3, 0));
Times ();
Push (Minor2 (k, l, 2, 0));
Push (Minor3 (i, k, l, 2, 3, 0));
Times ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (31);
Epsilon (j,4);
Epsilon (j,4);
Epsilon (i,3);
Epsilon (i,3);
Push (Minor2 (k, l, 1, 0));
Push (Integer (2));
Power ();
Push (Minor2 (k, l, 2, 0));
Push (Integer (2));
Power ();
Plus ();
Coefficient (Pop ());
Epsilon_Term (32);
Epsilon (j,4);
Epsilon (j,4);
Epsilon (i,2);
Push (Integer (2));
Push (Minor2 (k, l, 1, 0));
Push (Minor3 (i, k, l, 1, 2, 0));
Times ();
Push (Minor2 (k, l, 3, 0));
Push (Minor3 (i, k, l, 2, 3, 0));
Times ();
Plus ();
Minus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (33);
Epsilon (j,4);
Epsilon (j,4);
Epsilon (i,2);
Epsilon (i,3);
Push (Integer (-2));
Push (Minor2 (k, l, 2, 0));
Push (Minor2 (k, l, 3, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (34);
Epsilon (j,4);
Epsilon (j,4);
Epsilon (i,2);
Epsilon (i,2);
Push (Minor2 (k, l, 1, 0));
Push (Integer (2));
Power ();
Push (Minor2 (k, l, 3, 0));
Push (Integer (2));
Power ();
Plus ();
Coefficient (Pop ());
Epsilon_Term (35);
Epsilon (j,4);
Epsilon (j,4);
Epsilon (i,1);
Push (Integer (2));
Push (Minor2 (k, l, 2, 0));
Push (Minor3 (i, k, l, 1, 2, 0));
Times ();
Push (Minor2 (k, l, 3, 0));
Push (Minor3 (i, k, l, 1, 3, 0));
Times ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (36);
Epsilon (j,4);
Epsilon (j,4);
Epsilon (i,1);
Epsilon (i,3);
Push (Integer (-2));
Push (Minor2 (k, l, 1, 0));
Push (Minor2 (k, l, 3, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (37);
Epsilon (j,4);
Epsilon (j,4);
Epsilon (i,1);
Epsilon (i,2);
Push (Integer (-2));
Push (Minor2 (k, l, 1, 0));
Push (Minor2 (k, l, 2, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (38);
Epsilon (j,4);
Epsilon (j,4);
Epsilon (i,1);
Epsilon (i,1);
Push (Minor2 (k, l, 2, 0));
Push (Integer (2));
Power ();
Push (Minor2 (k, l, 3, 0));
Push (Integer (2));
Power ();
Plus ();
Coefficient (Pop ());
Epsilon_Term (39);
Epsilon (j,3);
Push (Integer (2));
Push (Integer (-2));
Push (Minor3 (i, k, l, 1, 2, 4));
Push (Minor4 (i, j, k, l, 1, 2, 3, 0));
Times ();
Times ();
Push (Integer (2));
Push (Minor3 (i, k, l, 1, 2, 0));
Push (Minor4 (i, j, k, l, 1, 2, 3, 4));
Times ();
Times ();
Push (Minor3 (i, k, l, 1, 4, 0));
Push (Minor4 (i, j, k, l, 1, 3, 4, 0));
Times ();
Push (Minor3 (i, k, l, 2, 4, 0));
Push (Minor4 (i, j, k, l, 2, 3, 4, 0));
Times ();
Plus ();
Plus ();
Minus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (40);
Epsilon (j,3);
Epsilon (i,4);
Push (Integer (2));
Push (Integer (2));
Push (Minor3 (i, k, l, 1, 2, 0));
Push (Minor3 (j, k, l, 1, 2, 3));
Times ();
Times ();
Push (Minor3 (i, k, l, 1, 4, 0));
Push (Minor3 (j, k, l, 1, 3, 0));
Times ();
Push (Minor3 (i, k, l, 2, 4, 0));
Push (Minor3 (j, k, l, 2, 3, 0));
Times ();
Plus ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (41);
Epsilon (j,3);
Epsilon (i,3);
Push (Integer (-2));
Push (Integer (2));
Push (Minor3 (i, k, l, 1, 2, 4));
Push (Minor3 (j, k, l, 1, 2, 0));
Times ();
Times ();
Push (Integer (2));
Push (Minor3 (i, k, l, 1, 2, 0));
Push (Minor3 (j, k, l, 1, 2, 4));
Times ();
Times ();
Push (Minor3 (i, k, l, 1, 4, 0));
Push (Minor3 (j, k, l, 1, 4, 0));
Times ();
Push (Minor3 (i, k, l, 2, 4, 0));
Push (Minor3 (j, k, l, 2, 4, 0));
Times ();
Plus ();
Plus ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (42);
Epsilon (j,3);
Epsilon (i,2);
Push (Integer (2));
Push (Integer (2));
Push (Minor3 (i, k, l, 1, 2, 4));
Push (Minor3 (j, k, l, 1, 3, 0));
Times ();
Times ();
Push (Integer (2));
Push (Minor3 (i, k, l, 1, 2, 0));
Push (Minor3 (j, k, l, 1, 3, 4));
Times ();
Times ();
Push (Minor3 (i, k, l, 2, 4, 0));
Push (Minor3 (j, k, l, 3, 4, 0));
Times ();
Push (Integer (2));
Push (Minor2 (k, l, 1, 4));
Push (Minor4 (i, j, k, l, 1, 2, 3, 0));
Times ();
Times ();
Push (Integer (2));
Push (Minor2 (k, l, 1, 0));
Push (Minor4 (i, j, k, l, 1, 2, 3, 4));
Times ();
Times ();
Push (Minor2 (k, l, 4, 0));
Push (Minor4 (i, j, k, l, 2, 3, 4, 0));
Times ();
Plus ();
Plus ();
Plus ();
Plus ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (43);
Epsilon (j,3);
Epsilon (i,2);
Epsilon (i,4);
Push (Integer (-4));
Push (Minor2 (k, l, 1, 0));
Push (Minor3 (j, k, l, 1, 2, 3));
Times ();
Times ();
Push (Integer (2));
Push (Minor2 (k, l, 4, 0));
Push (Minor3 (j, k, l, 2, 3, 0));
Times ();
Times ();
Plus ();
Coefficient (Pop ());
Epsilon_Term (44);
Epsilon (j,3);
Epsilon (i,2);
Epsilon (i,3);
Push (Integer (4));
Push (Minor2 (k, l, 1, 4));
Push (Minor3 (j, k, l, 1, 2, 0));
Times ();
Times ();
Push (Integer (4));
Push (Minor2 (k, l, 1, 0));
Push (Minor3 (j, k, l, 1, 2, 4));
Times ();
Times ();
Push (Integer (2));
Push (Minor2 (k, l, 4, 0));
Push (Minor3 (j, k, l, 2, 4, 0));
Times ();
Times ();
Minus ();
Plus ();
Coefficient (Pop ());
Epsilon_Term (45);
Epsilon (j,3);
Epsilon (i,2);
Epsilon (i,2);
Push (Integer (-4));
Push (Minor2 (k, l, 1, 4));
Push (Minor3 (j, k, l, 1, 3, 0));
Times ();
Times ();
Push (Integer (4));
Push (Minor2 (k, l, 1, 0));
Push (Minor3 (j, k, l, 1, 3, 4));
Times ();
Times ();
Push (Integer (2));
Push (Minor2 (k, l, 4, 0));
Push (Minor3 (j, k, l, 3, 4, 0));
Times ();
Times ();
Plus ();
Minus ();
Coefficient (Pop ());
Epsilon_Term (46);
Epsilon (j,3);
Epsilon (i,1);
Push (Integer (2));
Push (Integer (-2));
Push (Minor3 (i, k, l, 1, 2, 4));
Push (Minor3 (j, k, l, 2, 3, 0));
Times ();
Times ();
Push (Integer (2));
Push (Minor3 (i, k, l, 1, 2, 0));
Push (Minor3 (j, k, l, 2, 3, 4));
Times ();
Times ();
Push (Minor3 (i, k, l, 1, 4, 0));
Push (Minor3 (j, k, l, 3, 4, 0));
Times ();
Push (Integer (2));
Push (Minor2 (k, l, 2, 4));
Push (Minor4 (i, j, k, l, 1, 2, 3, 0));
Times ();
Times ();
Push (Integer (2));
Push (Minor2 (k, l, 2, 0));
Push (Minor4 (i, j, k, l, 1, 2, 3, 4));
Times ();
Times ();
Push (Minor2 (k, l, 4, 0));
Push (Minor4 (i, j, k, l, 1, 3, 4, 0));
Times ();
Plus ();
Minus ();
Minus ();
Plus ();
Minus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (47);
Epsilon (j,3);
Epsilon (i,1);
Epsilon (i,4);
Push (Integer (4));
Push (Minor2 (k, l, 2, 0));
Push (Minor3 (j, k, l, 1, 2, 3));
Times ();
Times ();
Push (Integer (2));
Push (Minor2 (k, l, 4, 0));
Push (Minor3 (j, k, l, 1, 3, 0));
Times ();
Times ();
Plus ();
Coefficient (Pop ());
Epsilon_Term (48);
Epsilon (j,3);
Epsilon (i,1);
Epsilon (i,3);
Push (Integer (-4));
Push (Minor2 (k, l, 2, 4));
Push (Minor3 (j, k, l, 1, 2, 0));
Times ();
Times ();
Push (Integer (4));
Push (Minor2 (k, l, 2, 0));
Push (Minor3 (j, k, l, 1, 2, 4));
Times ();
Times ();
Push (Integer (2));
Push (Minor2 (k, l, 4, 0));
Push (Minor3 (j, k, l, 1, 4, 0));
Times ();
Times ();
Minus ();
Minus ();
Coefficient (Pop ());
Epsilon_Term (49);
Epsilon (j,3);
Epsilon (i,1);
Epsilon (i,2);
Push (Integer (4));
Push (Minor2 (k, l, 2, 4));
Push (Minor3 (j, k, l, 1, 3, 0));
Times ();
Push (Minor2 (k, l, 2, 0));
Push (Minor3 (j, k, l, 1, 3, 4));
Times ();
Push (Minor2 (k, l, 1, 4));
Push (Minor3 (j, k, l, 2, 3, 0));
Times ();
Push (Minor2 (k, l, 1, 0));
Push (Minor3 (j, k, l, 2, 3, 4));
Times ();
Plus ();
Plus ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (50);
Epsilon (j,3);
Epsilon (i,1);
Epsilon (i,1);
Push (Integer (-4));
Push (Minor2 (k, l, 2, 4));
Push (Minor3 (j, k, l, 2, 3, 0));
Times ();
Times ();
Push (Integer (4));
Push (Minor2 (k, l, 2, 0));
Push (Minor3 (j, k, l, 2, 3, 4));
Times ();
Times ();
Push (Integer (2));
Push (Minor2 (k, l, 4, 0));
Push (Minor3 (j, k, l, 3, 4, 0));
Times ();
Times ();
Plus ();
Minus ();
Coefficient (Pop ());
Epsilon_Term (51);
Epsilon (j,3);
Epsilon (j,4);
Push (Integer (-2));
Push (Integer (2));
Push (Minor3 (i, k, l, 1, 2, 0));
Push (Minor3 (i, k, l, 1, 2, 3));
Times ();
Times ();
Push (Minor3 (i, k, l, 1, 3, 0));
Push (Minor3 (i, k, l, 1, 4, 0));
Times ();
Push (Minor3 (i, k, l, 2, 3, 0));
Push (Minor3 (i, k, l, 2, 4, 0));
Times ();
Plus ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (52);
Epsilon (j,3);
Epsilon (j,4);
Epsilon (i,3);
Push (Integer (2));
Push (Integer (-2));
Push (Minor2 (k, l, 1, 2));
Push (Minor3 (i, k, l, 1, 2, 0));
Times ();
Times ();
Push (Minor2 (k, l, 1, 0));
Push (Minor3 (i, k, l, 1, 4, 0));
Times ();
Push (Minor2 (k, l, 2, 0));
Push (Minor3 (i, k, l, 2, 4, 0));
Times ();
Plus ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (53);
Epsilon (j,3);
Epsilon (j,4);
Epsilon (i,2);
Push (Integer (4));
Push (Minor2 (k, l, 1, 3));
Push (Minor3 (i, k, l, 1, 2, 0));
Times ();
Times ();
Push (Integer (4));
Push (Minor2 (k, l, 1, 0));
Push (Minor3 (i, k, l, 1, 2, 3));
Times ();
Times ();
Push (Integer (2));
Push (Minor2 (k, l, 4, 0));
Push (Minor3 (i, k, l, 2, 3, 0));
Times ();
Times ();
Push (Integer (2));
Push (Minor2 (k, l, 3, 0));
Push (Minor3 (i, k, l, 2, 4, 0));
Times ();
Times ();
Minus ();
Minus ();
Plus ();
Coefficient (Pop ());
Epsilon_Term (54);
Epsilon (j,3);
Epsilon (j,4);
Epsilon (i,2);
Epsilon (i,3);
Push (Integer (4));
Push (Minor2 (k, l, 1, 0));
Push (Minor2 (k, l, 1, 2));
Times ();
Times ();
Push (Integer (2));
Push (Minor2 (k, l, 2, 0));
Push (Minor2 (k, l, 4, 0));
Times ();
Times ();
Plus ();
Coefficient (Pop ());
Epsilon_Term (55);
Epsilon (j,3);
Epsilon (j,4);
Epsilon (i,2);
Epsilon (i,2);
Push (Integer (-4));
Push (Minor2 (k, l, 1, 0));
Push (Minor2 (k, l, 1, 3));
Times ();
Times ();
Push (Integer (2));
Push (Minor2 (k, l, 3, 0));
Push (Minor2 (k, l, 4, 0));
Times ();
Times ();
Minus ();
Coefficient (Pop ());
Epsilon_Term (56);
Epsilon (j,3);
Epsilon (j,4);
Epsilon (i,1);
Push (Integer (-2));
Push (Integer (2));
Push (Minor2 (k, l, 2, 3));
Push (Minor3 (i, k, l, 1, 2, 0));
Times ();
Times ();
Push (Integer (2));
Push (Minor2 (k, l, 2, 0));
Push (Minor3 (i, k, l, 1, 2, 3));
Times ();
Times ();
Push (Minor2 (k, l, 4, 0));
Push (Minor3 (i, k, l, 1, 3, 0));
Times ();
Push (Minor2 (k, l, 3, 0));
Push (Minor3 (i, k, l, 1, 4, 0));
Times ();
Plus ();
Plus ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (57);
Epsilon (j,3);
Epsilon (j,4);
Epsilon (i,1);
Epsilon (i,3);
Push (Integer (-4));
Push (Minor2 (k, l, 1, 2));
Push (Minor2 (k, l, 2, 0));
Times ();
Times ();
Push (Integer (2));
Push (Minor2 (k, l, 1, 0));
Push (Minor2 (k, l, 4, 0));
Times ();
Times ();
Plus ();
Coefficient (Pop ());
Epsilon_Term (58);
Epsilon (j,3);
Epsilon (j,4);
Epsilon (i,1);
Epsilon (i,2);
Push (Integer (4));
Push (Minor2 (k, l, 1, 3));
Push (Minor2 (k, l, 2, 0));
Times ();
Push (Minor2 (k, l, 1, 0));
Push (Minor2 (k, l, 2, 3));
Times ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (59);
Epsilon (j,3);
Epsilon (j,4);
Epsilon (i,1);
Epsilon (i,1);
Push (Integer (-4));
Push (Minor2 (k, l, 2, 0));
Push (Minor2 (k, l, 2, 3));
Times ();
Times ();
Push (Integer (2));
Push (Minor2 (k, l, 3, 0));
Push (Minor2 (k, l, 4, 0));
Times ();
Times ();
Minus ();
Coefficient (Pop ());
Epsilon_Term (60);
Epsilon (j,3);
Epsilon (j,3);
Push (Integer (4));
Push (Minor3 (i, k, l, 1, 2, 0));
Push (Minor3 (i, k, l, 1, 2, 4));
Times ();
Times ();
Push (Minor3 (i, k, l, 1, 4, 0));
Push (Integer (2));
Power ();
Push (Minor3 (i, k, l, 2, 4, 0));
Push (Integer (2));
Power ();
Plus ();
Plus ();
Coefficient (Pop ());
Epsilon_Term (61);
Epsilon (j,3);
Epsilon (j,3);
Epsilon (i,2);
Push (Integer (-4));
Push (Minor2 (k, l, 1, 4));
Push (Minor3 (i, k, l, 1, 2, 0));
Times ();
Times ();
Push (Integer (4));
Push (Minor2 (k, l, 1, 0));
Push (Minor3 (i, k, l, 1, 2, 4));
Times ();
Times ();
Push (Integer (2));
Push (Minor2 (k, l, 4, 0));
Push (Minor3 (i, k, l, 2, 4, 0));
Times ();
Times ();
Plus ();
Minus ();
Coefficient (Pop ());
Epsilon_Term (62);
Epsilon (j,3);
Epsilon (j,3);
Epsilon (i,2);
Epsilon (i,2);
Push (Integer (4));
Push (Minor2 (k, l, 1, 0));
Push (Minor2 (k, l, 1, 4));
Times ();
Times ();
Push (Minor2 (k, l, 4, 0));
Push (Integer (2));
Power ();
Plus ();
Coefficient (Pop ());
Epsilon_Term (63);
Epsilon (j,3);
Epsilon (j,3);
Epsilon (i,1);
Push (Integer (4));
Push (Minor2 (k, l, 2, 4));
Push (Minor3 (i, k, l, 1, 2, 0));
Times ();
Times ();
Push (Integer (4));
Push (Minor2 (k, l, 2, 0));
Push (Minor3 (i, k, l, 1, 2, 4));
Times ();
Times ();
Push (Integer (2));
Push (Minor2 (k, l, 4, 0));
Push (Minor3 (i, k, l, 1, 4, 0));
Times ();
Times ();
Plus ();
Plus ();
Coefficient (Pop ());
Epsilon_Term (64);
Epsilon (j,3);
Epsilon (j,3);
Epsilon (i,1);
Epsilon (i,2);
Push (Integer (-4));
Push (Minor2 (k, l, 1, 4));
Push (Minor2 (k, l, 2, 0));
Times ();
Push (Minor2 (k, l, 1, 0));
Push (Minor2 (k, l, 2, 4));
Times ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (65);
Epsilon (j,3);
Epsilon (j,3);
Epsilon (i,1);
Epsilon (i,1);
Push (Integer (4));
Push (Minor2 (k, l, 2, 0));
Push (Minor2 (k, l, 2, 4));
Times ();
Times ();
Push (Minor2 (k, l, 4, 0));
Push (Integer (2));
Power ();
Plus ();
Coefficient (Pop ());
Epsilon_Term (66);
Epsilon (j,2);
Push (Integer (2));
Push (Integer (2));
Push (Minor3 (i, k, l, 1, 3, 4));
Push (Minor4 (i, j, k, l, 1, 2, 3, 0));
Times ();
Times ();
Push (Integer (2));
Push (Minor3 (i, k, l, 1, 3, 0));
Push (Minor4 (i, j, k, l, 1, 2, 3, 4));
Times ();
Times ();
Push (Minor3 (i, k, l, 1, 4, 0));
Push (Minor4 (i, j, k, l, 1, 2, 4, 0));
Times ();
Push (Minor3 (i, k, l, 3, 4, 0));
Push (Minor4 (i, j, k, l, 2, 3, 4, 0));
Times ();
Minus ();
Plus ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (67);
Epsilon (j,2);
Epsilon (i,4);
Push (Integer (2));
Push (Minor3 (i, k, l, 1, 4, 0));
Push (Minor3 (j, k, l, 1, 2, 0));
Times ();
Push (Integer (2));
Push (Minor3 (i, k, l, 1, 3, 0));
Push (Minor3 (j, k, l, 1, 2, 3));
Times ();
Times ();
Push (Minor3 (i, k, l, 3, 4, 0));
Push (Minor3 (j, k, l, 2, 3, 0));
Times ();
Minus ();
Minus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (68);
Epsilon (j,2);
Epsilon (i,3);
Push (Integer (4));
Push (Minor3 (i, k, l, 1, 3, 4));
Push (Minor3 (j, k, l, 1, 2, 0));
Times ();
Times ();
Push (Integer (4));
Push (Minor3 (i, k, l, 1, 3, 0));
Push (Minor3 (j, k, l, 1, 2, 4));
Times ();
Times ();
Push (Integer (2));
Push (Minor3 (i, k, l, 3, 4, 0));
Push (Minor3 (j, k, l, 2, 4, 0));
Times ();
Times ();
Plus ();
Plus ();
Coefficient (Pop ());
Epsilon_Term (69);
Epsilon (j,2);
Epsilon (i,2);
Push (Integer (-2));
Push (Integer (2));
Push (Minor3 (i, k, l, 1, 3, 4));
Push (Minor3 (j, k, l, 1, 3, 0));
Times ();
Times ();
Push (Integer (2));
Push (Minor3 (i, k, l, 1, 3, 0));
Push (Minor3 (j, k, l, 1, 3, 4));
Times ();
Times ();
Push (Minor3 (i, k, l, 1, 4, 0));
Push (Minor3 (j, k, l, 1, 4, 0));
Times ();
Push (Minor3 (i, k, l, 3, 4, 0));
Push (Minor3 (j, k, l, 3, 4, 0));
Times ();
Plus ();
Plus ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (70);
Epsilon (j,2);
Epsilon (i,1);
Push (Integer (2));
Push (Integer (2));
Push (Minor3 (i, k, l, 1, 3, 4));
Push (Minor3 (j, k, l, 2, 3, 0));
Times ();
Times ();
Push (Integer (2));
Push (Minor3 (i, k, l, 1, 3, 0));
Push (Minor3 (j, k, l, 2, 3, 4));
Times ();
Times ();
Push (Minor3 (i, k, l, 1, 4, 0));
Push (Minor3 (j, k, l, 2, 4, 0));
Times ();
Push (Integer (2));
Push (Minor2 (k, l, 3, 4));
Push (Minor4 (i, j, k, l, 1, 2, 3, 0));
Times ();
Times ();
Push (Integer (2));
Push (Minor2 (k, l, 3, 0));
Push (Minor4 (i, j, k, l, 1, 2, 3, 4));
Times ();
Times ();
Push (Minor2 (k, l, 4, 0));
Push (Minor4 (i, j, k, l, 1, 2, 4, 0));
Times ();
Plus ();
Plus ();
Plus ();
Plus ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (71);
Epsilon (j,2);
Epsilon (i,1);
Epsilon (i,4);
Push (Integer (2));
Push (Minor2 (k, l, 4, 0));
Push (Minor3 (j, k, l, 1, 2, 0));
Times ();
Times ();
Push (Integer (4));
Push (Minor2 (k, l, 3, 0));
Push (Minor3 (j, k, l, 1, 2, 3));
Times ();
Times ();
Minus ();
Coefficient (Pop ());
Epsilon_Term (72);
Epsilon (j,2);
Epsilon (i,1);
Epsilon (i,3);
Push (Integer (4));
Push (Minor2 (k, l, 3, 4));
Push (Minor3 (j, k, l, 1, 2, 0));
Times ();
Push (Minor2 (k, l, 3, 0));
Push (Minor3 (j, k, l, 1, 2, 4));
Times ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (73);
Epsilon (j,2);
Epsilon (i,1);
Epsilon (i,2);
Push (Integer (-4));
Push (Minor2 (k, l, 3, 4));
Push (Minor3 (j, k, l, 1, 3, 0));
Times ();
Times ();
Push (Integer (4));
Push (Minor2 (k, l, 3, 0));
Push (Minor3 (j, k, l, 1, 3, 4));
Times ();
Times ();
Push (Integer (2));
Push (Minor2 (k, l, 4, 0));
Push (Minor3 (j, k, l, 1, 4, 0));
Times ();
Times ();
Minus ();
Minus ();
Coefficient (Pop ());
Epsilon_Term (74);
Epsilon (j,2);
Epsilon (i,1);
Epsilon (i,1);
Push (Integer (4));
Push (Minor2 (k, l, 3, 4));
Push (Minor3 (j, k, l, 2, 3, 0));
Times ();
Times ();
Push (Integer (4));
Push (Minor2 (k, l, 3, 0));
Push (Minor3 (j, k, l, 2, 3, 4));
Times ();
Times ();
Push (Integer (2));
Push (Minor2 (k, l, 4, 0));
Push (Minor3 (j, k, l, 2, 4, 0));
Times ();
Times ();
Plus ();
Plus ();
Coefficient (Pop ());
Epsilon_Term (75);
Epsilon (j,2);
Epsilon (j,4);
Push (Integer (2));
Push (Integer (2));
Push (Minor3 (i, k, l, 1, 2, 3));
Push (Minor3 (i, k, l, 1, 3, 0));
Times ();
Times ();
Push (Minor3 (i, k, l, 1, 2, 0));
Push (Minor3 (i, k, l, 1, 4, 0));
Times ();
Push (Minor3 (i, k, l, 2, 3, 0));
Push (Minor3 (i, k, l, 3, 4, 0));
Times ();
Plus ();
Minus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (76);
Epsilon (j,2);
Epsilon (j,4);
Epsilon (i,3);
Push (Integer (4));
Push (Minor2 (k, l, 1, 2));
Push (Minor3 (i, k, l, 1, 3, 0));
Times ();
Times ();
Push (Integer (2));
Push (Minor2 (k, l, 2, 0));
Push (Minor3 (i, k, l, 3, 4, 0));
Times ();
Times ();
Minus ();
Coefficient (Pop ());
Epsilon_Term (77);
Epsilon (j,2);
Epsilon (j,4);
Epsilon (i,2);
Push (Integer (2));
Push (Integer (-2));
Push (Minor2 (k, l, 1, 3));
Push (Minor3 (i, k, l, 1, 3, 0));
Times ();
Times ();
Push (Minor2 (k, l, 1, 0));
Push (Minor3 (i, k, l, 1, 4, 0));
Times ();
Push (Minor2 (k, l, 3, 0));
Push (Minor3 (i, k, l, 3, 4, 0));
Times ();
Plus ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (78);
Epsilon (j,2);
Epsilon (j,4);
Epsilon (i,1);
Push (Integer (-2));
Push (Minor2 (k, l, 4, 0));
Push (Minor3 (i, k, l, 1, 2, 0));
Times ();
Times ();
Push (Integer (4));
Push (Minor2 (k, l, 3, 0));
Push (Minor3 (i, k, l, 1, 2, 3));
Times ();
Times ();
Push (Integer (4));
Push (Minor2 (k, l, 2, 3));
Push (Minor3 (i, k, l, 1, 3, 0));
Times ();
Times ();
Push (Integer (2));
Push (Minor2 (k, l, 2, 0));
Push (Minor3 (i, k, l, 1, 4, 0));
Times ();
Times ();
Minus ();
Plus ();
Plus ();
Coefficient (Pop ());
Epsilon_Term (79);
Epsilon (j,2);
Epsilon (j,4);
Epsilon (i,1);
Epsilon (i,3);
Push (Integer (4));
Push (Minor2 (k, l, 1, 2));
Push (Minor2 (k, l, 3, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (80);
Epsilon (j,2);
Epsilon (j,4);
Epsilon (i,1);
Epsilon (i,2);
Push (Integer (-4));
Push (Minor2 (k, l, 1, 3));
Push (Minor2 (k, l, 3, 0));
Times ();
Times ();
Push (Integer (2));
Push (Minor2 (k, l, 1, 0));
Push (Minor2 (k, l, 4, 0));
Times ();
Times ();
Plus ();
Coefficient (Pop ());
Epsilon_Term (81);
Epsilon (j,2);
Epsilon (j,4);
Epsilon (i,1);
Epsilon (i,1);
Push (Integer (4));
Push (Minor2 (k, l, 2, 3));
Push (Minor2 (k, l, 3, 0));
Times ();
Times ();
Push (Integer (2));
Push (Minor2 (k, l, 2, 0));
Push (Minor2 (k, l, 4, 0));
Times ();
Times ();
Minus ();
Coefficient (Pop ());
Epsilon_Term (82);
Epsilon (j,2);
Epsilon (j,3);
Push (Integer (-4));
Push (Minor3 (i, k, l, 1, 2, 4));
Push (Minor3 (i, k, l, 1, 3, 0));
Times ();
Times ();
Push (Integer (4));
Push (Minor3 (i, k, l, 1, 2, 0));
Push (Minor3 (i, k, l, 1, 3, 4));
Times ();
Times ();
Push (Integer (2));
Push (Minor3 (i, k, l, 2, 4, 0));
Push (Minor3 (i, k, l, 3, 4, 0));
Times ();
Times ();
Minus ();
Minus ();
Coefficient (Pop ());
Epsilon_Term (83);
Epsilon (j,2);
Epsilon (j,3);
Epsilon (i,2);
Push (Integer (4));
Push (Minor2 (k, l, 1, 4));
Push (Minor3 (i, k, l, 1, 3, 0));
Times ();
Times ();
Push (Integer (4));
Push (Minor2 (k, l, 1, 0));
Push (Minor3 (i, k, l, 1, 3, 4));
Times ();
Times ();
Push (Integer (2));
Push (Minor2 (k, l, 4, 0));
Push (Minor3 (i, k, l, 3, 4, 0));
Times ();
Times ();
Minus ();
Plus ();
Coefficient (Pop ());
Epsilon_Term (84);
Epsilon (j,2);
Epsilon (j,3);
Epsilon (i,1);
Push (Integer (-4));
Push (Minor2 (k, l, 3, 4));
Push (Minor3 (i, k, l, 1, 2, 0));
Times ();
Push (Minor2 (k, l, 3, 0));
Push (Minor3 (i, k, l, 1, 2, 4));
Times ();
Push (Minor2 (k, l, 2, 4));
Push (Minor3 (i, k, l, 1, 3, 0));
Times ();
Push (Minor2 (k, l, 2, 0));
Push (Minor3 (i, k, l, 1, 3, 4));
Times ();
Plus ();
Plus ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (85);
Epsilon (j,2);
Epsilon (j,3);
Epsilon (i,1);
Epsilon (i,2);
Push (Integer (4));
Push (Minor2 (k, l, 1, 4));
Push (Minor2 (k, l, 3, 0));
Times ();
Push (Minor2 (k, l, 1, 0));
Push (Minor2 (k, l, 3, 4));
Times ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (86);
Epsilon (j,2);
Epsilon (j,3);
Epsilon (i,1);
Epsilon (i,1);
Push (Integer (-4));
Push (Minor2 (k, l, 2, 4));
Push (Minor2 (k, l, 3, 0));
Times ();
Push (Minor2 (k, l, 2, 0));
Push (Minor2 (k, l, 3, 4));
Times ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (87);
Epsilon (j,2);
Epsilon (j,2);
Push (Integer (4));
Push (Minor3 (i, k, l, 1, 3, 0));
Push (Minor3 (i, k, l, 1, 3, 4));
Times ();
Times ();
Push (Minor3 (i, k, l, 1, 4, 0));
Push (Integer (2));
Power ();
Push (Minor3 (i, k, l, 3, 4, 0));
Push (Integer (2));
Power ();
Plus ();
Plus ();
Coefficient (Pop ());
Epsilon_Term (88);
Epsilon (j,2);
Epsilon (j,2);
Epsilon (i,1);
Push (Integer (4));
Push (Minor2 (k, l, 3, 4));
Push (Minor3 (i, k, l, 1, 3, 0));
Times ();
Times ();
Push (Integer (4));
Push (Minor2 (k, l, 3, 0));
Push (Minor3 (i, k, l, 1, 3, 4));
Times ();
Times ();
Push (Integer (2));
Push (Minor2 (k, l, 4, 0));
Push (Minor3 (i, k, l, 1, 4, 0));
Times ();
Times ();
Plus ();
Plus ();
Coefficient (Pop ());
Epsilon_Term (89);
Epsilon (j,2);
Epsilon (j,2);
Epsilon (i,1);
Epsilon (i,1);
Push (Integer (4));
Push (Minor2 (k, l, 3, 0));
Push (Minor2 (k, l, 3, 4));
Times ();
Times ();
Push (Minor2 (k, l, 4, 0));
Push (Integer (2));
Power ();
Plus ();
Coefficient (Pop ());
Epsilon_Term (90);
Epsilon (j,1);
Push (Integer (-2));
Push (Integer (2));
Push (Minor3 (i, k, l, 2, 3, 4));
Push (Minor4 (i, j, k, l, 1, 2, 3, 0));
Times ();
Times ();
Push (Integer (2));
Push (Minor3 (i, k, l, 2, 3, 0));
Push (Minor4 (i, j, k, l, 1, 2, 3, 4));
Times ();
Times ();
Push (Minor3 (i, k, l, 2, 4, 0));
Push (Minor4 (i, j, k, l, 1, 2, 4, 0));
Times ();
Push (Minor3 (i, k, l, 3, 4, 0));
Push (Minor4 (i, j, k, l, 1, 3, 4, 0));
Times ();
Plus ();
Plus ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (91);
Epsilon (j,1);
Epsilon (i,4);
Push (Integer (-2));
Push (Minor3 (i, k, l, 2, 4, 0));
Push (Minor3 (j, k, l, 1, 2, 0));
Times ();
Times ();
Push (Integer (4));
Push (Minor3 (i, k, l, 2, 3, 0));
Push (Minor3 (j, k, l, 1, 2, 3));
Times ();
Times ();
Push (Integer (2));
Push (Minor3 (i, k, l, 3, 4, 0));
Push (Minor3 (j, k, l, 1, 3, 0));
Times ();
Times ();
Minus ();
Plus ();
Coefficient (Pop ());
Epsilon_Term (92);
Epsilon (j,1);
Epsilon (i,3);
Push (Integer (-4));
Push (Minor3 (i, k, l, 2, 3, 4));
Push (Minor3 (j, k, l, 1, 2, 0));
Times ();
Times ();
Push (Integer (4));
Push (Minor3 (i, k, l, 2, 3, 0));
Push (Minor3 (j, k, l, 1, 2, 4));
Times ();
Times ();
Push (Integer (2));
Push (Minor3 (i, k, l, 3, 4, 0));
Push (Minor3 (j, k, l, 1, 4, 0));
Times ();
Times ();
Plus ();
Minus ();
Coefficient (Pop ());
Epsilon_Term (93);
Epsilon (j,1);
Epsilon (i,2);
Push (Integer (4));
Push (Minor3 (i, k, l, 2, 3, 4));
Push (Minor3 (j, k, l, 1, 3, 0));
Times ();
Times ();
Push (Integer (4));
Push (Minor3 (i, k, l, 2, 3, 0));
Push (Minor3 (j, k, l, 1, 3, 4));
Times ();
Times ();
Push (Integer (2));
Push (Minor3 (i, k, l, 2, 4, 0));
Push (Minor3 (j, k, l, 1, 4, 0));
Times ();
Times ();
Plus ();
Plus ();
Coefficient (Pop ());
Epsilon_Term (94);
Epsilon (j,1);
Epsilon (i,1);
Push (Integer (-2));
Push (Integer (2));
Push (Minor3 (i, k, l, 2, 3, 4));
Push (Minor3 (j, k, l, 2, 3, 0));
Times ();
Times ();
Push (Integer (2));
Push (Minor3 (i, k, l, 2, 3, 0));
Push (Minor3 (j, k, l, 2, 3, 4));
Times ();
Times ();
Push (Minor3 (i, k, l, 2, 4, 0));
Push (Minor3 (j, k, l, 2, 4, 0));
Times ();
Push (Minor3 (i, k, l, 3, 4, 0));
Push (Minor3 (j, k, l, 3, 4, 0));
Times ();
Plus ();
Plus ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (95);
Epsilon (j,1);
Epsilon (j,4);
Push (Integer (2));
Push (Integer (-2));
Push (Minor3 (i, k, l, 1, 2, 3));
Push (Minor3 (i, k, l, 2, 3, 0));
Times ();
Times ();
Push (Minor3 (i, k, l, 1, 2, 0));
Push (Minor3 (i, k, l, 2, 4, 0));
Times ();
Push (Minor3 (i, k, l, 1, 3, 0));
Push (Minor3 (i, k, l, 3, 4, 0));
Times ();
Plus ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (96);
Epsilon (j,1);
Epsilon (j,4);
Epsilon (i,3);
Push (Integer (-4));
Push (Minor2 (k, l, 1, 2));
Push (Minor3 (i, k, l, 2, 3, 0));
Times ();
Times ();
Push (Integer (2));
Push (Minor2 (k, l, 1, 0));
Push (Minor3 (i, k, l, 3, 4, 0));
Times ();
Times ();
Minus ();
Coefficient (Pop ());
Epsilon_Term (97);
Epsilon (j,1);
Epsilon (j,4);
Epsilon (i,2);
Push (Integer (4));
Push (Minor2 (k, l, 1, 3));
Push (Minor3 (i, k, l, 2, 3, 0));
Times ();
Times ();
Push (Integer (2));
Push (Minor2 (k, l, 1, 0));
Push (Minor3 (i, k, l, 2, 4, 0));
Times ();
Times ();
Minus ();
Coefficient (Pop ());
Epsilon_Term (98);
Epsilon (j,1);
Epsilon (j,4);
Epsilon (i,1);
Push (Integer (2));
Push (Integer (-2));
Push (Minor2 (k, l, 2, 3));
Push (Minor3 (i, k, l, 2, 3, 0));
Times ();
Times ();
Push (Minor2 (k, l, 2, 0));
Push (Minor3 (i, k, l, 2, 4, 0));
Times ();
Push (Minor2 (k, l, 3, 0));
Push (Minor3 (i, k, l, 3, 4, 0));
Times ();
Plus ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (99);
Epsilon (j,1);
Epsilon (j,3);
Push (Integer (4));
Push (Minor3 (i, k, l, 1, 2, 4));
Push (Minor3 (i, k, l, 2, 3, 0));
Times ();
Times ();
Push (Integer (4));
Push (Minor3 (i, k, l, 1, 2, 0));
Push (Minor3 (i, k, l, 2, 3, 4));
Times ();
Times ();
Push (Integer (2));
Push (Minor3 (i, k, l, 1, 4, 0));
Push (Minor3 (i, k, l, 3, 4, 0));
Times ();
Times ();
Minus ();
Plus ();
Coefficient (Pop ());
Epsilon_Term (100);
Epsilon (j,1);
Epsilon (j,3);
Epsilon (i,2);
Push (Integer (-4));
Push (Minor2 (k, l, 1, 4));
Push (Minor3 (i, k, l, 2, 3, 0));
Times ();
Push (Minor2 (k, l, 1, 0));
Push (Minor3 (i, k, l, 2, 3, 4));
Times ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (101);
Epsilon (j,1);
Epsilon (j,3);
Epsilon (i,1);
Push (Integer (4));
Push (Minor2 (k, l, 2, 4));
Push (Minor3 (i, k, l, 2, 3, 0));
Times ();
Times ();
Push (Integer (4));
Push (Minor2 (k, l, 2, 0));
Push (Minor3 (i, k, l, 2, 3, 4));
Times ();
Times ();
Push (Integer (2));
Push (Minor2 (k, l, 4, 0));
Push (Minor3 (i, k, l, 3, 4, 0));
Times ();
Times ();
Minus ();
Plus ();
Coefficient (Pop ());
Epsilon_Term (102);
Epsilon (j,1);
Epsilon (j,2);
Push (Integer (-4));
Push (Minor3 (i, k, l, 1, 3, 4));
Push (Minor3 (i, k, l, 2, 3, 0));
Times ();
Times ();
Push (Integer (4));
Push (Minor3 (i, k, l, 1, 3, 0));
Push (Minor3 (i, k, l, 2, 3, 4));
Times ();
Times ();
Push (Integer (2));
Push (Minor3 (i, k, l, 1, 4, 0));
Push (Minor3 (i, k, l, 2, 4, 0));
Times ();
Times ();
Minus ();
Minus ();
Coefficient (Pop ());
Epsilon_Term (103);
Epsilon (j,1);
Epsilon (j,2);
Epsilon (i,1);
Push (Integer (-4));
Push (Minor2 (k, l, 3, 4));
Push (Minor3 (i, k, l, 2, 3, 0));
Times ();
Times ();
Push (Integer (4));
Push (Minor2 (k, l, 3, 0));
Push (Minor3 (i, k, l, 2, 3, 4));
Times ();
Times ();
Push (Integer (2));
Push (Minor2 (k, l, 4, 0));
Push (Minor3 (i, k, l, 2, 4, 0));
Times ();
Times ();
Minus ();
Minus ();
Coefficient (Pop ());
Epsilon_Term (104);
Epsilon (j,1);
Epsilon (j,1);
Push (Integer (4));
Push (Minor3 (i, k, l, 2, 3, 0));
Push (Minor3 (i, k, l, 2, 3, 4));
Times ();
Times ();
Push (Minor3 (i, k, l, 2, 4, 0));
Push (Integer (2));
Power ();
Push (Minor3 (i, k, l, 3, 4, 0));
Push (Integer (2));
Power ();
Plus ();
Plus ();
Coefficient (Pop ());
Epsilon_Term (105);
Epsilon (k,4);
Push (Integer (2));
Push (Integer (-2));
Push (Minor3 (i, j, l, 1, 2, 3));
Push (Minor4 (i, j, k, l, 1, 2, 3, 0));
Times ();
Times ();
Push (Minor3 (i, j, l, 1, 2, 0));
Push (Minor4 (i, j, k, l, 1, 2, 4, 0));
Times ();
Push (Minor3 (i, j, l, 1, 3, 0));
Push (Minor4 (i, j, k, l, 1, 3, 4, 0));
Times ();
Push (Minor3 (i, j, l, 2, 3, 0));
Push (Minor4 (i, j, k, l, 2, 3, 4, 0));
Times ();
Plus ();
Plus ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (106);
Epsilon (k,4);
Epsilon (i,4);
Push (Integer (2));
Push (Minor3 (i, j, l, 1, 2, 0));
Push (Minor3 (j, k, l, 1, 2, 0));
Times ();
Push (Minor3 (i, j, l, 1, 3, 0));
Push (Minor3 (j, k, l, 1, 3, 0));
Times ();
Push (Minor3 (i, j, l, 2, 3, 0));
Push (Minor3 (j, k, l, 2, 3, 0));
Times ();
Plus ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (107);
Epsilon (k,4);
Epsilon (i,3);
Push (Integer (-2));
Push (Integer (2));
Push (Minor3 (i, j, l, 1, 2, 3));
Push (Minor3 (j, k, l, 1, 2, 0));
Times ();
Times ();
Push (Minor3 (i, j, l, 1, 3, 0));
Push (Minor3 (j, k, l, 1, 4, 0));
Times ();
Push (Minor3 (i, j, l, 2, 3, 0));
Push (Minor3 (j, k, l, 2, 4, 0));
Times ();
Push (Integer (2));
Push (Minor2 (j, l, 1, 2));
Push (Minor4 (i, j, k, l, 1, 2, 3, 0));
Times ();
Times ();
Push (Minor2 (j, l, 1, 0));
Push (Minor4 (i, j, k, l, 1, 3, 4, 0));
Times ();
Push (Minor2 (j, l, 2, 0));
Push (Minor4 (i, j, k, l, 2, 3, 4, 0));
Times ();
Plus ();
Plus ();
Plus ();
Plus ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (108);
Epsilon (k,4);
Epsilon (i,3);
Epsilon (i,4);
Push (Integer (-2));
Push (Minor2 (j, l, 1, 0));
Push (Minor3 (j, k, l, 1, 3, 0));
Times ();
Push (Minor2 (j, l, 2, 0));
Push (Minor3 (j, k, l, 2, 3, 0));
Times ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (109);
Epsilon (k,4);
Epsilon (i,3);
Epsilon (i,3);
Push (Integer (2));
Push (Integer (-2));
Push (Minor2 (j, l, 1, 2));
Push (Minor3 (j, k, l, 1, 2, 0));
Times ();
Times ();
Push (Minor2 (j, l, 1, 0));
Push (Minor3 (j, k, l, 1, 4, 0));
Times ();
Push (Minor2 (j, l, 2, 0));
Push (Minor3 (j, k, l, 2, 4, 0));
Times ();
Plus ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (110);
Epsilon (k,4);
Epsilon (i,2);
Push (Integer (2));
Push (Integer (2));
Push (Minor3 (i, j, l, 1, 2, 3));
Push (Minor3 (j, k, l, 1, 3, 0));
Times ();
Times ();
Push (Minor3 (i, j, l, 1, 2, 0));
Push (Minor3 (j, k, l, 1, 4, 0));
Times ();
Push (Minor3 (i, j, l, 2, 3, 0));
Push (Minor3 (j, k, l, 3, 4, 0));
Times ();
Push (Integer (2));
Push (Minor2 (j, l, 1, 3));
Push (Minor4 (i, j, k, l, 1, 2, 3, 0));
Times ();
Times ();
Push (Minor2 (j, l, 1, 0));
Push (Minor4 (i, j, k, l, 1, 2, 4, 0));
Times ();
Push (Minor2 (j, l, 3, 0));
Push (Minor4 (i, j, k, l, 2, 3, 4, 0));
Times ();
Plus ();
Minus ();
Plus ();
Plus ();
Minus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (111);
Epsilon (k,4);
Epsilon (i,2);
Epsilon (i,4);
Push (Integer (2));
Push (Minor2 (j, l, 1, 0));
Push (Minor3 (j, k, l, 1, 2, 0));
Times ();
Push (Minor2 (j, l, 3, 0));
Push (Minor3 (j, k, l, 2, 3, 0));
Times ();
Plus ();
Minus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (112);
Epsilon (k,4);
Epsilon (i,2);
Epsilon (i,3);
Push (Integer (4));
Push (Minor2 (j, l, 1, 3));
Push (Minor3 (j, k, l, 1, 2, 0));
Times ();
Times ();
Push (Integer (4));
Push (Minor2 (j, l, 1, 2));
Push (Minor3 (j, k, l, 1, 3, 0));
Times ();
Times ();
Push (Integer (2));
Push (Minor2 (j, l, 3, 0));
Push (Minor3 (j, k, l, 2, 4, 0));
Times ();
Times ();
Push (Integer (2));
Push (Minor2 (j, l, 2, 0));
Push (Minor3 (j, k, l, 3, 4, 0));
Times ();
Times ();
Minus ();
Minus ();
Plus ();
Coefficient (Pop ());
Epsilon_Term (113);
Epsilon (k,4);
Epsilon (i,2);
Epsilon (i,2);
Push (Integer (2));
Push (Integer (-2));
Push (Minor2 (j, l, 1, 3));
Push (Minor3 (j, k, l, 1, 3, 0));
Times ();
Times ();
Push (Minor2 (j, l, 1, 0));
Push (Minor3 (j, k, l, 1, 4, 0));
Times ();
Push (Minor2 (j, l, 3, 0));
Push (Minor3 (j, k, l, 3, 4, 0));
Times ();
Plus ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (114);
Epsilon (k,4);
Epsilon (i,1);
Push (Integer (2));
Push (Integer (-2));
Push (Minor3 (i, j, l, 1, 2, 3));
Push (Minor3 (j, k, l, 2, 3, 0));
Times ();
Times ();
Push (Minor3 (i, j, l, 1, 2, 0));
Push (Minor3 (j, k, l, 2, 4, 0));
Times ();
Push (Minor3 (i, j, l, 1, 3, 0));
Push (Minor3 (j, k, l, 3, 4, 0));
Times ();
Push (Integer (2));
Push (Minor2 (j, l, 2, 3));
Push (Minor4 (i, j, k, l, 1, 2, 3, 0));
Times ();
Times ();
Push (Minor2 (j, l, 2, 0));
Push (Minor4 (i, j, k, l, 1, 2, 4, 0));
Times ();
Push (Minor2 (j, l, 3, 0));
Push (Minor4 (i, j, k, l, 1, 3, 4, 0));
Times ();
Plus ();
Plus ();
Minus ();
Plus ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (115);
Epsilon (k,4);
Epsilon (i,1);
Epsilon (i,4);
Push (Integer (2));
Push (Minor2 (j, l, 2, 0));
Push (Minor3 (j, k, l, 1, 2, 0));
Times ();
Push (Minor2 (j, l, 3, 0));
Push (Minor3 (j, k, l, 1, 3, 0));
Times ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (116);
Epsilon (k,4);
Epsilon (i,1);
Epsilon (i,3);
Push (Integer (-2));
Push (Integer (2));
Push (Minor2 (j, l, 2, 3));
Push (Minor3 (j, k, l, 1, 2, 0));
Times ();
Times ();
Push (Minor2 (j, l, 3, 0));
Push (Minor3 (j, k, l, 1, 4, 0));
Times ();
Push (Integer (2));
Push (Minor2 (j, l, 1, 2));
Push (Minor3 (j, k, l, 2, 3, 0));
Times ();
Times ();
Push (Minor2 (j, l, 1, 0));
Push (Minor3 (j, k, l, 3, 4, 0));
Times ();
Plus ();
Plus ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (117);
Epsilon (k,4);
Epsilon (i,1);
Epsilon (i,2);
Push (Integer (4));
Push (Minor2 (j, l, 2, 3));
Push (Minor3 (j, k, l, 1, 3, 0));
Times ();
Times ();
Push (Integer (2));
Push (Minor2 (j, l, 2, 0));
Push (Minor3 (j, k, l, 1, 4, 0));
Times ();
Times ();
Push (Integer (4));
Push (Minor2 (j, l, 1, 3));
Push (Minor3 (j, k, l, 2, 3, 0));
Times ();
Times ();
Push (Integer (2));
Push (Minor2 (j, l, 1, 0));
Push (Minor3 (j, k, l, 2, 4, 0));
Times ();
Times ();
Minus ();
Plus ();
Minus ();
Coefficient (Pop ());
Epsilon_Term (118);
Epsilon (k,4);
Epsilon (i,1);
Epsilon (i,1);
Push (Integer (2));
Push (Integer (-2));
Push (Minor2 (j, l, 2, 3));
Push (Minor3 (j, k, l, 2, 3, 0));
Times ();
Times ();
Push (Minor2 (j, l, 2, 0));
Push (Minor3 (j, k, l, 2, 4, 0));
Times ();
Push (Minor2 (j, l, 3, 0));
Push (Minor3 (j, k, l, 3, 4, 0));
Times ();
Plus ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (119);
Epsilon (k,4);
Epsilon (j,4);
Push (Integer (-2));
Push (Minor3 (i, j, l, 1, 2, 0));
Push (Minor3 (i, k, l, 1, 2, 0));
Times ();
Push (Minor3 (i, j, l, 1, 3, 0));
Push (Minor3 (i, k, l, 1, 3, 0));
Times ();
Push (Minor3 (i, j, l, 2, 3, 0));
Push (Minor3 (i, k, l, 2, 3, 0));
Times ();
Plus ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (120);
Epsilon (k,4);
Epsilon (j,4);
Epsilon (i,3);
Push (Integer (2));
Push (Minor2 (k, l, 1, 0));
Push (Minor3 (i, j, l, 1, 3, 0));
Times ();
Push (Minor2 (k, l, 2, 0));
Push (Minor3 (i, j, l, 2, 3, 0));
Times ();
Push (Minor2 (j, l, 1, 0));
Push (Minor3 (i, k, l, 1, 3, 0));
Times ();
Push (Minor2 (j, l, 2, 0));
Push (Minor3 (i, k, l, 2, 3, 0));
Times ();
Plus ();
Plus ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (121);
Epsilon (k,4);
Epsilon (j,4);
Epsilon (i,3);
Epsilon (i,3);
Push (Integer (-2));
Push (Minor2 (j, l, 1, 0));
Push (Minor2 (k, l, 1, 0));
Times ();
Push (Minor2 (j, l, 2, 0));
Push (Minor2 (k, l, 2, 0));
Times ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (122);
Epsilon (k,4);
Epsilon (j,4);
Epsilon (i,2);
Push (Integer (2));
Push (Minor2 (k, l, 1, 0));
Push (Minor3 (i, j, l, 1, 2, 0));
Times ();
Push (Minor2 (k, l, 3, 0));
Push (Minor3 (i, j, l, 2, 3, 0));
Times ();
Push (Minor2 (j, l, 1, 0));
Push (Minor3 (i, k, l, 1, 2, 0));
Times ();
Push (Minor2 (j, l, 3, 0));
Push (Minor3 (i, k, l, 2, 3, 0));
Times ();
Minus ();
Plus ();
Minus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (123);
Epsilon (k,4);
Epsilon (j,4);
Epsilon (i,2);
Epsilon (i,3);
Push (Integer (2));
Push (Minor2 (j, l, 3, 0));
Push (Minor2 (k, l, 2, 0));
Times ();
Push (Minor2 (j, l, 2, 0));
Push (Minor2 (k, l, 3, 0));
Times ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (124);
Epsilon (k,4);
Epsilon (j,4);
Epsilon (i,2);
Epsilon (i,2);
Push (Integer (-2));
Push (Minor2 (j, l, 1, 0));
Push (Minor2 (k, l, 1, 0));
Times ();
Push (Minor2 (j, l, 3, 0));
Push (Minor2 (k, l, 3, 0));
Times ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (125);
Epsilon (k,4);
Epsilon (j,4);
Epsilon (i,1);
Push (Integer (-2));
Push (Minor2 (k, l, 2, 0));
Push (Minor3 (i, j, l, 1, 2, 0));
Times ();
Push (Minor2 (k, l, 3, 0));
Push (Minor3 (i, j, l, 1, 3, 0));
Times ();
Push (Minor2 (j, l, 2, 0));
Push (Minor3 (i, k, l, 1, 2, 0));
Times ();
Push (Minor2 (j, l, 3, 0));
Push (Minor3 (i, k, l, 1, 3, 0));
Times ();
Plus ();
Plus ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (126);
Epsilon (k,4);
Epsilon (j,4);
Epsilon (i,1);
Epsilon (i,3);
Push (Integer (2));
Push (Minor2 (j, l, 3, 0));
Push (Minor2 (k, l, 1, 0));
Times ();
Push (Minor2 (j, l, 1, 0));
Push (Minor2 (k, l, 3, 0));
Times ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (127);
Epsilon (k,4);
Epsilon (j,4);
Epsilon (i,1);
Epsilon (i,2);
Push (Integer (2));
Push (Minor2 (j, l, 2, 0));
Push (Minor2 (k, l, 1, 0));
Times ();
Push (Minor2 (j, l, 1, 0));
Push (Minor2 (k, l, 2, 0));
Times ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (128);
Epsilon (k,4);
Epsilon (j,4);
Epsilon (i,1);
Epsilon (i,1);
Push (Integer (-2));
Push (Minor2 (j, l, 2, 0));
Push (Minor2 (k, l, 2, 0));
Times ();
Push (Minor2 (j, l, 3, 0));
Push (Minor2 (k, l, 3, 0));
Times ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (129);
Epsilon (k,4);
Epsilon (j,3);
Push (Integer (2));
Push (Integer (2));
Push (Minor3 (i, j, l, 1, 2, 3));
Push (Minor3 (i, k, l, 1, 2, 0));
Times ();
Times ();
Push (Minor3 (i, j, l, 1, 3, 0));
Push (Minor3 (i, k, l, 1, 4, 0));
Times ();
Push (Minor3 (i, j, l, 2, 3, 0));
Push (Minor3 (i, k, l, 2, 4, 0));
Times ();
Push (Integer (2));
Push (Minor2 (i, l, 1, 2));
Push (Minor4 (i, j, k, l, 1, 2, 3, 0));
Times ();
Times ();
Push (Minor2 (i, l, 1, 0));
Push (Minor4 (i, j, k, l, 1, 3, 4, 0));
Times ();
Push (Minor2 (i, l, 2, 0));
Push (Minor4 (i, j, k, l, 2, 3, 4, 0));
Times ();
Plus ();
Plus ();
Plus ();
Plus ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (130);
Epsilon (k,4);
Epsilon (j,3);
Epsilon (i,4);
Push (Integer (2));
Push (Minor2 (i, l, 1, 0));
Push (Minor3 (j, k, l, 1, 3, 0));
Times ();
Push (Minor2 (i, l, 2, 0));
Push (Minor3 (j, k, l, 2, 3, 0));
Times ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (131);
Epsilon (k,4);
Epsilon (j,3);
Epsilon (i,3);
Push (Integer (2));
Push (Integer (2));
Push (Minor2 (j, l, 1, 2));
Push (Minor3 (i, k, l, 1, 2, 0));
Times ();
Times ();
Push (Minor2 (j, l, 1, 0));
Push (Minor3 (i, k, l, 1, 4, 0));
Times ();
Push (Minor2 (j, l, 2, 0));
Push (Minor3 (i, k, l, 2, 4, 0));
Times ();
Push (Integer (2));
Push (Minor2 (i, l, 1, 2));
Push (Minor3 (j, k, l, 1, 2, 0));
Times ();
Times ();
Push (Minor2 (i, l, 1, 0));
Push (Minor3 (j, k, l, 1, 4, 0));
Times ();
Push (Minor2 (i, l, 2, 0));
Push (Minor3 (j, k, l, 2, 4, 0));
Times ();
Minus ();
Minus ();
Plus ();
Minus ();
Minus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (132);
Epsilon (k,4);
Epsilon (j,3);
Epsilon (i,2);
Push (Integer (2));
Push (Integer (-2));
Push (Minor2 (k, l, 1, 0));
Push (Minor3 (i, j, l, 1, 2, 3));
Times ();
Times ();
Push (Minor2 (k, l, 4, 0));
Push (Minor3 (i, j, l, 2, 3, 0));
Times ();
Push (Integer (2));
Push (Minor2 (j, l, 1, 3));
Push (Minor3 (i, k, l, 1, 2, 0));
Times ();
Times ();
Push (Minor2 (j, l, 3, 0));
Push (Minor3 (i, k, l, 2, 4, 0));
Times ();
Push (Integer (2));
Push (Minor2 (i, l, 1, 2));
Push (Minor3 (j, k, l, 1, 3, 0));
Times ();
Times ();
Push (Minor2 (i, l, 2, 0));
Push (Minor3 (j, k, l, 3, 4, 0));
Times ();
Push (Integer (2));
Push (Minor1 (l, 1));
Push (Minor4 (i, j, k, l, 1, 2, 3, 0));
Times ();
Times ();
Push (Minor4 (i, j, k, l, 2, 3, 4, 0));
Plus ();
Minus ();
Plus ();
Minus ();
Plus ();
Minus ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (133);
Epsilon (k,4);
Epsilon (j,3);
Epsilon (i,2);
Epsilon (i,4);
Push (Integer (2));
Push (Minor3 (j, k, l, 2, 3, 0));
Times ();
Coefficient (Pop ());
Epsilon_Term (134);
Epsilon (k,4);
Epsilon (j,3);
Epsilon (i,2);
Epsilon (i,3);
Push (Integer (-2));
Push (Integer (2));
Push (Minor2 (j, l, 1, 2));
Push (Minor2 (k, l, 1, 0));
Times ();
Times ();
Push (Minor2 (j, l, 2, 0));
Push (Minor2 (k, l, 4, 0));
Times ();
Push (Integer (2));
Push (Minor1 (l, 1));
Push (Minor3 (j, k, l, 1, 2, 0));
Times ();
Times ();
Push (Minor3 (j, k, l, 2, 4, 0));
Plus ();
Plus ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (135);
Epsilon (k,4);
Epsilon (j,3);
Epsilon (i,2);
Epsilon (i,2);
Push (Integer (2));
Push (Integer (2));
Push (Minor2 (j, l, 1, 3));
Push (Minor2 (k, l, 1, 0));
Times ();
Times ();
Push (Minor2 (j, l, 3, 0));
Push (Minor2 (k, l, 4, 0));
Times ();
Push (Integer (2));
Push (Minor1 (l, 1));
Push (Minor3 (j, k, l, 1, 3, 0));
Times ();
Times ();
Push (Minor3 (j, k, l, 3, 4, 0));
Plus ();
Plus ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (136);
Epsilon (k,4);
Epsilon (j,3);
Epsilon (i,1);
Push (Integer (2));
Push (Integer (2));
Push (Minor2 (k, l, 2, 0));
Push (Minor3 (i, j, l, 1, 2, 3));
Times ();
Times ();
Push (Minor2 (k, l, 4, 0));
Push (Minor3 (i, j, l, 1, 3, 0));
Times ();
Push (Integer (2));
Push (Minor2 (j, l, 2, 3));
Push (Minor3 (i, k, l, 1, 2, 0));
Times ();
Times ();
Push (Minor2 (j, l, 3, 0));
Push (Minor3 (i, k, l, 1, 4, 0));
Times ();
Push (Integer (2));
Push (Minor2 (i, l, 1, 2));
Push (Minor3 (j, k, l, 2, 3, 0));
Times ();
Times ();
Push (Minor2 (i, l, 1, 0));
Push (Minor3 (j, k, l, 3, 4, 0));
Times ();
Push (Integer (2));
Push (Minor1 (l, 2));
Push (Minor4 (i, j, k, l, 1, 2, 3, 0));
Times ();
Times ();
Push (Minor4 (i, j, k, l, 1, 3, 4, 0));
Plus ();
Plus ();
Plus ();
Plus ();
Plus ();
Plus ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (137);
Epsilon (k,4);
Epsilon (j,3);
Epsilon (i,1);
Epsilon (i,4);
Push (Integer (2));
Push (Minor3 (j, k, l, 1, 3, 0));
Times ();
Coefficient (Pop ());
Epsilon_Term (138);
Epsilon (k,4);
Epsilon (j,3);
Epsilon (i,1);
Epsilon (i,3);
Push (Integer (4));
Push (Minor2 (j, l, 1, 2));
Push (Minor2 (k, l, 2, 0));
Times ();
Times ();
Push (Integer (2));
Push (Minor2 (j, l, 1, 0));
Push (Minor2 (k, l, 4, 0));
Times ();
Times ();
Push (Integer (4));
Push (Minor1 (l, 2));
Push (Minor3 (j, k, l, 1, 2, 0));
Times ();
Times ();
Push (Integer (2));
Push (Minor3 (j, k, l, 1, 4, 0));
Times ();
Minus ();
Plus ();
Minus ();
Coefficient (Pop ());
Epsilon_Term (139);
Epsilon (k,4);
Epsilon (j,3);
Epsilon (i,1);
Epsilon (i,2);
Push (Integer (-4));
Push (Minor2 (j, l, 2, 3));
Push (Minor2 (k, l, 1, 0));
Times ();
Push (Minor2 (j, l, 1, 3));
Push (Minor2 (k, l, 2, 0));
Times ();
Push (Minor1 (l, 2));
Push (Minor3 (j, k, l, 1, 3, 0));
Times ();
Push (Minor1 (l, 1));
Push (Minor3 (j, k, l, 2, 3, 0));
Times ();
Plus ();
Plus ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (140);
Epsilon (k,4);
Epsilon (j,3);
Epsilon (i,1);
Epsilon (i,1);
Push (Integer (2));
Push (Integer (2));
Push (Minor2 (j, l, 2, 3));
Push (Minor2 (k, l, 2, 0));
Times ();
Times ();
Push (Minor2 (j, l, 3, 0));
Push (Minor2 (k, l, 4, 0));
Times ();
Push (Integer (2));
Push (Minor1 (l, 2));
Push (Minor3 (j, k, l, 2, 3, 0));
Times ();
Times ();
Push (Minor3 (j, k, l, 3, 4, 0));
Plus ();
Plus ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (141);
Epsilon (k,4);
Epsilon (j,3);
Epsilon (j,4);
Push (Integer (-2));
Push (Minor2 (i, l, 1, 0));
Push (Minor3 (i, k, l, 1, 3, 0));
Times ();
Push (Minor2 (i, l, 2, 0));
Push (Minor3 (i, k, l, 2, 3, 0));
Times ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (142);
Epsilon (k,4);
Epsilon (j,3);
Epsilon (j,4);
Epsilon (i,3);
Push (Integer (2));
Push (Minor2 (i, l, 1, 0));
Push (Minor2 (k, l, 1, 0));
Times ();
Push (Minor2 (i, l, 2, 0));
Push (Minor2 (k, l, 2, 0));
Times ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (143);
Epsilon (k,4);
Epsilon (j,3);
Epsilon (j,4);
Epsilon (i,2);
Push (Integer (-2));
Push (Minor2 (i, l, 2, 0));
Push (Minor2 (k, l, 3, 0));
Times ();
Push (Minor3 (i, k, l, 2, 3, 0));
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (144);
Epsilon (k,4);
Epsilon (j,3);
Epsilon (j,4);
Epsilon (i,2);
Epsilon (i,3);
Push (Integer (2));
Push (Minor2 (k, l, 2, 0));
Times ();
Coefficient (Pop ());
Epsilon_Term (145);
Epsilon (k,4);
Epsilon (j,3);
Epsilon (j,4);
Epsilon (i,2);
Epsilon (i,2);
Push (Integer (-2));
Push (Minor2 (k, l, 3, 0));
Times ();
Coefficient (Pop ());
Epsilon_Term (146);
Epsilon (k,4);
Epsilon (j,3);
Epsilon (j,4);
Epsilon (i,1);
Push (Integer (-2));
Push (Minor2 (i, l, 1, 0));
Push (Minor2 (k, l, 3, 0));
Times ();
Push (Minor3 (i, k, l, 1, 3, 0));
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (147);
Epsilon (k,4);
Epsilon (j,3);
Epsilon (j,4);
Epsilon (i,1);
Epsilon (i,3);
Push (Integer (2));
Push (Minor2 (k, l, 1, 0));
Times ();
Coefficient (Pop ());
Epsilon_Term (148);
Epsilon (k,4);
Epsilon (j,3);
Epsilon (j,4);
Epsilon (i,1);
Epsilon (i,1);
Push (Integer (-2));
Push (Minor2 (k, l, 3, 0));
Times ();
Coefficient (Pop ());
Epsilon_Term (149);
Epsilon (k,4);
Epsilon (j,3);
Epsilon (j,3);
Push (Integer (2));
Push (Integer (-2));
Push (Minor2 (i, l, 1, 2));
Push (Minor3 (i, k, l, 1, 2, 0));
Times ();
Times ();
Push (Minor2 (i, l, 1, 0));
Push (Minor3 (i, k, l, 1, 4, 0));
Times ();
Push (Minor2 (i, l, 2, 0));
Push (Minor3 (i, k, l, 2, 4, 0));
Times ();
Plus ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (150);
Epsilon (k,4);
Epsilon (j,3);
Epsilon (j,3);
Epsilon (i,2);
Push (Integer (2));
Push (Integer (2));
Push (Minor2 (i, l, 1, 2));
Push (Minor2 (k, l, 1, 0));
Times ();
Times ();
Push (Minor2 (i, l, 2, 0));
Push (Minor2 (k, l, 4, 0));
Times ();
Push (Integer (2));
Push (Minor1 (l, 1));
Push (Minor3 (i, k, l, 1, 2, 0));
Times ();
Times ();
Push (Minor3 (i, k, l, 2, 4, 0));
Plus ();
Plus ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (151);
Epsilon (k,4);
Epsilon (j,3);
Epsilon (j,3);
Epsilon (i,2);
Epsilon (i,2);
Push (Integer (-4));
Push (Minor1 (l, 1));
Push (Minor2 (k, l, 1, 0));
Times ();
Times ();
Push (Integer (2));
Push (Minor2 (k, l, 4, 0));
Times ();
Plus ();
Coefficient (Pop ());
Epsilon_Term (152);
Epsilon (k,4);
Epsilon (j,3);
Epsilon (j,3);
Epsilon (i,1);
Push (Integer (2));
Push (Integer (-2));
Push (Minor2 (i, l, 1, 2));
Push (Minor2 (k, l, 2, 0));
Times ();
Times ();
Push (Minor2 (i, l, 1, 0));
Push (Minor2 (k, l, 4, 0));
Times ();
Push (Integer (2));
Push (Minor1 (l, 2));
Push (Minor3 (i, k, l, 1, 2, 0));
Times ();
Times ();
Push (Minor3 (i, k, l, 1, 4, 0));
Plus ();
Minus ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (153);
Epsilon (k,4);
Epsilon (j,3);
Epsilon (j,3);
Epsilon (i,1);
Epsilon (i,2);
Push (Integer (4));
Push (Minor1 (l, 2));
Push (Minor2 (k, l, 1, 0));
Times ();
Push (Minor1 (l, 1));
Push (Minor2 (k, l, 2, 0));
Times ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (154);
Epsilon (k,4);
Epsilon (j,3);
Epsilon (j,3);
Epsilon (i,1);
Epsilon (i,1);
Push (Integer (-4));
Push (Minor1 (l, 2));
Push (Minor2 (k, l, 2, 0));
Times ();
Times ();
Push (Integer (2));
Push (Minor2 (k, l, 4, 0));
Times ();
Plus ();
Coefficient (Pop ());
Epsilon_Term (155);
Epsilon (k,4);
Epsilon (j,2);
Push (Integer (2));
Push (Integer (-2));
Push (Minor3 (i, j, l, 1, 2, 3));
Push (Minor3 (i, k, l, 1, 3, 0));
Times ();
Times ();
Push (Minor3 (i, j, l, 1, 2, 0));
Push (Minor3 (i, k, l, 1, 4, 0));
Times ();
Push (Minor3 (i, j, l, 2, 3, 0));
Push (Minor3 (i, k, l, 3, 4, 0));
Times ();
Push (Integer (2));
Push (Minor2 (i, l, 1, 3));
Push (Minor4 (i, j, k, l, 1, 2, 3, 0));
Times ();
Times ();
Push (Minor2 (i, l, 1, 0));
Push (Minor4 (i, j, k, l, 1, 2, 4, 0));
Times ();
Push (Minor2 (i, l, 3, 0));
Push (Minor4 (i, j, k, l, 2, 3, 4, 0));
Times ();
Minus ();
Plus ();
Minus ();
Minus ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (156);
Epsilon (k,4);
Epsilon (j,2);
Epsilon (i,4);
Push (Integer (2));
Push (Minor2 (i, l, 1, 0));
Push (Minor3 (j, k, l, 1, 2, 0));
Times ();
Push (Minor2 (i, l, 3, 0));
Push (Minor3 (j, k, l, 2, 3, 0));
Times ();
Minus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (157);
Epsilon (k,4);
Epsilon (j,2);
Epsilon (i,3);
Push (Integer (2));
Push (Integer (-2));
Push (Minor2 (j, l, 1, 2));
Push (Minor3 (i, k, l, 1, 3, 0));
Times ();
Times ();
Push (Minor2 (j, l, 2, 0));
Push (Minor3 (i, k, l, 3, 4, 0));
Times ();
Push (Integer (2));
Push (Minor2 (i, l, 1, 3));
Push (Minor3 (j, k, l, 1, 2, 0));
Times ();
Times ();
Push (Minor2 (i, l, 3, 0));
Push (Minor3 (j, k, l, 2, 4, 0));
Times ();
Plus ();
Minus ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (158);
Epsilon (k,4);
Epsilon (j,2);
Epsilon (i,2);
Push (Integer (2));
Push (Integer (2));
Push (Minor2 (j, l, 1, 3));
Push (Minor3 (i, k, l, 1, 3, 0));
Times ();
Times ();
Push (Minor2 (j, l, 1, 0));
Push (Minor3 (i, k, l, 1, 4, 0));
Times ();
Push (Minor2 (j, l, 3, 0));
Push (Minor3 (i, k, l, 3, 4, 0));
Times ();
Push (Integer (2));
Push (Minor2 (i, l, 1, 3));
Push (Minor3 (j, k, l, 1, 3, 0));
Times ();
Times ();
Push (Minor2 (i, l, 1, 0));
Push (Minor3 (j, k, l, 1, 4, 0));
Times ();
Push (Minor2 (i, l, 3, 0));
Push (Minor3 (j, k, l, 3, 4, 0));
Times ();
Minus ();
Minus ();
Plus ();
Minus ();
Minus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (159);
Epsilon (k,4);
Epsilon (j,2);
Epsilon (i,1);
Push (Integer (2));
Push (Minor2 (k, l, 4, 0));
Push (Minor3 (i, j, l, 1, 2, 0));
Times ();
Push (Integer (2));
Push (Minor2 (k, l, 3, 0));
Push (Minor3 (i, j, l, 1, 2, 3));
Times ();
Times ();
Push (Integer (2));
Push (Minor2 (j, l, 2, 3));
Push (Minor3 (i, k, l, 1, 3, 0));
Times ();
Times ();
Push (Minor2 (j, l, 2, 0));
Push (Minor3 (i, k, l, 1, 4, 0));
Times ();
Push (Integer (2));
Push (Minor2 (i, l, 1, 3));
Push (Minor3 (j, k, l, 2, 3, 0));
Times ();
Times ();
Push (Minor2 (i, l, 1, 0));
Push (Minor3 (j, k, l, 2, 4, 0));
Times ();
Push (Integer (2));
Push (Minor1 (l, 3));
Push (Minor4 (i, j, k, l, 1, 2, 3, 0));
Times ();
Times ();
Push (Minor4 (i, j, k, l, 1, 2, 4, 0));
Plus ();
Minus ();
Plus ();
Minus ();
Plus ();
Minus ();
Minus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (160);
Epsilon (k,4);
Epsilon (j,2);
Epsilon (i,1);
Epsilon (i,4);
Push (Integer (2));
Push (Minor3 (j, k, l, 1, 2, 0));
Times ();
Coefficient (Pop ());
Epsilon_Term (161);
Epsilon (k,4);
Epsilon (j,2);
Epsilon (i,1);
Epsilon (i,3);
Push (Integer (-4));
Push (Minor2 (j, l, 1, 2));
Push (Minor2 (k, l, 3, 0));
Times ();
Push (Minor1 (l, 3));
Push (Minor3 (j, k, l, 1, 2, 0));
Times ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (162);
Epsilon (k,4);
Epsilon (j,2);
Epsilon (i,1);
Epsilon (i,2);
Push (Integer (4));
Push (Minor2 (j, l, 1, 3));
Push (Minor2 (k, l, 3, 0));
Times ();
Times ();
Push (Integer (2));
Push (Minor2 (j, l, 1, 0));
Push (Minor2 (k, l, 4, 0));
Times ();
Times ();
Push (Integer (4));
Push (Minor1 (l, 3));
Push (Minor3 (j, k, l, 1, 3, 0));
Times ();
Times ();
Push (Integer (2));
Push (Minor3 (j, k, l, 1, 4, 0));
Times ();
Minus ();
Plus ();
Minus ();
Coefficient (Pop ());
Epsilon_Term (163);
Epsilon (k,4);
Epsilon (j,2);
Epsilon (i,1);
Epsilon (i,1);
Push (Integer (2));
Push (Integer (-2));
Push (Minor2 (j, l, 2, 3));
Push (Minor2 (k, l, 3, 0));
Times ();
Times ();
Push (Minor2 (j, l, 2, 0));
Push (Minor2 (k, l, 4, 0));
Times ();
Push (Integer (2));
Push (Minor1 (l, 3));
Push (Minor3 (j, k, l, 2, 3, 0));
Times ();
Times ();
Push (Minor3 (j, k, l, 2, 4, 0));
Plus ();
Minus ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (164);
Epsilon (k,4);
Epsilon (j,2);
Epsilon (j,4);
Push (Integer (2));
Push (Minor2 (i, l, 1, 0));
Push (Minor3 (i, k, l, 1, 2, 0));
Times ();
Push (Minor2 (i, l, 3, 0));
Push (Minor3 (i, k, l, 2, 3, 0));
Times ();
Plus ();
Minus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (165);
Epsilon (k,4);
Epsilon (j,2);
Epsilon (j,4);
Epsilon (i,3);
Push (Integer (-2));
Push (Minor2 (i, l, 3, 0));
Push (Minor2 (k, l, 2, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (166);
Epsilon (k,4);
Epsilon (j,2);
Epsilon (j,4);
Epsilon (i,2);
Push (Integer (2));
Push (Minor2 (i, l, 1, 0));
Push (Minor2 (k, l, 1, 0));
Times ();
Push (Minor2 (i, l, 3, 0));
Push (Minor2 (k, l, 3, 0));
Times ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (167);
Epsilon (k,4);
Epsilon (j,2);
Epsilon (j,4);
Epsilon (i,1);
Push (Integer (-2));
Push (Minor2 (i, l, 1, 0));
Push (Minor2 (k, l, 2, 0));
Times ();
Push (Minor3 (i, k, l, 1, 2, 0));
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (168);
Epsilon (k,4);
Epsilon (j,2);
Epsilon (j,4);
Epsilon (i,1);
Epsilon (i,2);
Push (Integer (2));
Push (Minor2 (k, l, 1, 0));
Times ();
Coefficient (Pop ());
Epsilon_Term (169);
Epsilon (k,4);
Epsilon (j,2);
Epsilon (j,4);
Epsilon (i,1);
Epsilon (i,1);
Push (Integer (-2));
Push (Minor2 (k, l, 2, 0));
Times ();
Coefficient (Pop ());
Epsilon_Term (170);
Epsilon (k,4);
Epsilon (j,2);
Epsilon (j,3);
Push (Integer (4));
Push (Minor2 (i, l, 1, 3));
Push (Minor3 (i, k, l, 1, 2, 0));
Times ();
Times ();
Push (Integer (4));
Push (Minor2 (i, l, 1, 2));
Push (Minor3 (i, k, l, 1, 3, 0));
Times ();
Times ();
Push (Integer (2));
Push (Minor2 (i, l, 3, 0));
Push (Minor3 (i, k, l, 2, 4, 0));
Times ();
Times ();
Push (Integer (2));
Push (Minor2 (i, l, 2, 0));
Push (Minor3 (i, k, l, 3, 4, 0));
Times ();
Times ();
Minus ();
Minus ();
Plus ();
Coefficient (Pop ());
Epsilon_Term (171);
Epsilon (k,4);
Epsilon (j,2);
Epsilon (j,3);
Epsilon (i,2);
Push (Integer (-2));
Push (Integer (2));
Push (Minor2 (i, l, 1, 3));
Push (Minor2 (k, l, 1, 0));
Times ();
Times ();
Push (Minor2 (i, l, 3, 0));
Push (Minor2 (k, l, 4, 0));
Times ();
Push (Integer (2));
Push (Minor1 (l, 1));
Push (Minor3 (i, k, l, 1, 3, 0));
Times ();
Times ();
Push (Minor3 (i, k, l, 3, 4, 0));
Plus ();
Plus ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (172);
Epsilon (k,4);
Epsilon (j,2);
Epsilon (j,3);
Epsilon (i,1);
Push (Integer (4));
Push (Minor2 (i, l, 1, 3));
Push (Minor2 (k, l, 2, 0));
Times ();
Push (Minor2 (i, l, 1, 2));
Push (Minor2 (k, l, 3, 0));
Times ();
Push (Minor1 (l, 3));
Push (Minor3 (i, k, l, 1, 2, 0));
Times ();
Push (Minor1 (l, 2));
Push (Minor3 (i, k, l, 1, 3, 0));
Times ();
Plus ();
Plus ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (173);
Epsilon (k,4);
Epsilon (j,2);
Epsilon (j,3);
Epsilon (i,1);
Epsilon (i,2);
Push (Integer (-4));
Push (Minor1 (l, 3));
Push (Minor2 (k, l, 1, 0));
Times ();
Push (Minor1 (l, 1));
Push (Minor2 (k, l, 3, 0));
Times ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (174);
Epsilon (k,4);
Epsilon (j,2);
Epsilon (j,3);
Epsilon (i,1);
Epsilon (i,1);
Push (Integer (4));
Push (Minor1 (l, 3));
Push (Minor2 (k, l, 2, 0));
Times ();
Push (Minor1 (l, 2));
Push (Minor2 (k, l, 3, 0));
Times ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (175);
Epsilon (k,4);
Epsilon (j,2);
Epsilon (j,2);
Push (Integer (2));
Push (Integer (-2));
Push (Minor2 (i, l, 1, 3));
Push (Minor3 (i, k, l, 1, 3, 0));
Times ();
Times ();
Push (Minor2 (i, l, 1, 0));
Push (Minor3 (i, k, l, 1, 4, 0));
Times ();
Push (Minor2 (i, l, 3, 0));
Push (Minor3 (i, k, l, 3, 4, 0));
Times ();
Plus ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (176);
Epsilon (k,4);
Epsilon (j,2);
Epsilon (j,2);
Epsilon (i,1);
Push (Integer (2));
Push (Integer (-2));
Push (Minor2 (i, l, 1, 3));
Push (Minor2 (k, l, 3, 0));
Times ();
Times ();
Push (Minor2 (i, l, 1, 0));
Push (Minor2 (k, l, 4, 0));
Times ();
Push (Integer (2));
Push (Minor1 (l, 3));
Push (Minor3 (i, k, l, 1, 3, 0));
Times ();
Times ();
Push (Minor3 (i, k, l, 1, 4, 0));
Plus ();
Minus ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (177);
Epsilon (k,4);
Epsilon (j,2);
Epsilon (j,2);
Epsilon (i,1);
Epsilon (i,1);
Push (Integer (-4));
Push (Minor1 (l, 3));
Push (Minor2 (k, l, 3, 0));
Times ();
Times ();
Push (Integer (2));
Push (Minor2 (k, l, 4, 0));
Times ();
Plus ();
Coefficient (Pop ());
Epsilon_Term (178);
Epsilon (k,4);
Epsilon (j,1);
Push (Integer (2));
Push (Integer (2));
Push (Minor3 (i, j, l, 1, 2, 3));
Push (Minor3 (i, k, l, 2, 3, 0));
Times ();
Times ();
Push (Minor3 (i, j, l, 1, 2, 0));
Push (Minor3 (i, k, l, 2, 4, 0));
Times ();
Push (Minor3 (i, j, l, 1, 3, 0));
Push (Minor3 (i, k, l, 3, 4, 0));
Times ();
Push (Integer (2));
Push (Minor2 (i, l, 2, 3));
Push (Minor4 (i, j, k, l, 1, 2, 3, 0));
Times ();
Times ();
Push (Minor2 (i, l, 2, 0));
Push (Minor4 (i, j, k, l, 1, 2, 4, 0));
Times ();
Push (Minor2 (i, l, 3, 0));
Push (Minor4 (i, j, k, l, 1, 3, 4, 0));
Times ();
Minus ();
Minus ();
Plus ();
Minus ();
Minus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (179);
Epsilon (k,4);
Epsilon (j,1);
Epsilon (i,4);
Push (Integer (-2));
Push (Minor2 (i, l, 2, 0));
Push (Minor3 (j, k, l, 1, 2, 0));
Times ();
Push (Minor2 (i, l, 3, 0));
Push (Minor3 (j, k, l, 1, 3, 0));
Times ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (180);
Epsilon (k,4);
Epsilon (j,1);
Epsilon (i,3);
Push (Integer (2));
Push (Integer (2));
Push (Minor2 (j, l, 1, 2));
Push (Minor3 (i, k, l, 2, 3, 0));
Times ();
Times ();
Push (Minor2 (j, l, 1, 0));
Push (Minor3 (i, k, l, 3, 4, 0));
Times ();
Push (Integer (2));
Push (Minor2 (i, l, 2, 3));
Push (Minor3 (j, k, l, 1, 2, 0));
Times ();
Times ();
Push (Minor2 (i, l, 3, 0));
Push (Minor3 (j, k, l, 1, 4, 0));
Times ();
Plus ();
Plus ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (181);
Epsilon (k,4);
Epsilon (j,1);
Epsilon (i,2);
Push (Integer (2));
Push (Integer (-2));
Push (Minor2 (j, l, 1, 3));
Push (Minor3 (i, k, l, 2, 3, 0));
Times ();
Times ();
Push (Minor2 (j, l, 1, 0));
Push (Minor3 (i, k, l, 2, 4, 0));
Times ();
Push (Integer (2));
Push (Minor2 (i, l, 2, 3));
Push (Minor3 (j, k, l, 1, 3, 0));
Times ();
Times ();
Push (Minor2 (i, l, 2, 0));
Push (Minor3 (j, k, l, 1, 4, 0));
Times ();
Plus ();
Minus ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (182);
Epsilon (k,4);
Epsilon (j,1);
Epsilon (i,1);
Push (Integer (2));
Push (Integer (2));
Push (Minor2 (j, l, 2, 3));
Push (Minor3 (i, k, l, 2, 3, 0));
Times ();
Times ();
Push (Minor2 (j, l, 2, 0));
Push (Minor3 (i, k, l, 2, 4, 0));
Times ();
Push (Minor2 (j, l, 3, 0));
Push (Minor3 (i, k, l, 3, 4, 0));
Times ();
Push (Integer (2));
Push (Minor2 (i, l, 2, 3));
Push (Minor3 (j, k, l, 2, 3, 0));
Times ();
Times ();
Push (Minor2 (i, l, 2, 0));
Push (Minor3 (j, k, l, 2, 4, 0));
Times ();
Push (Minor2 (i, l, 3, 0));
Push (Minor3 (j, k, l, 3, 4, 0));
Times ();
Minus ();
Minus ();
Plus ();
Minus ();
Minus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (183);
Epsilon (k,4);
Epsilon (j,1);
Epsilon (j,4);
Push (Integer (2));
Push (Minor2 (i, l, 2, 0));
Push (Minor3 (i, k, l, 1, 2, 0));
Times ();
Push (Minor2 (i, l, 3, 0));
Push (Minor3 (i, k, l, 1, 3, 0));
Times ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (184);
Epsilon (k,4);
Epsilon (j,1);
Epsilon (j,4);
Epsilon (i,3);
Push (Integer (-2));
Push (Minor2 (i, l, 3, 0));
Push (Minor2 (k, l, 1, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (185);
Epsilon (k,4);
Epsilon (j,1);
Epsilon (j,4);
Epsilon (i,2);
Push (Integer (-2));
Push (Minor2 (i, l, 2, 0));
Push (Minor2 (k, l, 1, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (186);
Epsilon (k,4);
Epsilon (j,1);
Epsilon (j,4);
Epsilon (i,1);
Push (Integer (2));
Push (Minor2 (i, l, 2, 0));
Push (Minor2 (k, l, 2, 0));
Times ();
Push (Minor2 (i, l, 3, 0));
Push (Minor2 (k, l, 3, 0));
Times ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (187);
Epsilon (k,4);
Epsilon (j,1);
Epsilon (j,3);
Push (Integer (-2));
Push (Integer (2));
Push (Minor2 (i, l, 2, 3));
Push (Minor3 (i, k, l, 1, 2, 0));
Times ();
Times ();
Push (Minor2 (i, l, 3, 0));
Push (Minor3 (i, k, l, 1, 4, 0));
Times ();
Push (Integer (2));
Push (Minor2 (i, l, 1, 2));
Push (Minor3 (i, k, l, 2, 3, 0));
Times ();
Times ();
Push (Minor2 (i, l, 1, 0));
Push (Minor3 (i, k, l, 3, 4, 0));
Times ();
Plus ();
Plus ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (188);
Epsilon (k,4);
Epsilon (j,1);
Epsilon (j,3);
Epsilon (i,2);
Push (Integer (4));
Push (Minor2 (i, l, 2, 3));
Push (Minor2 (k, l, 1, 0));
Times ();
Push (Minor1 (l, 1));
Push (Minor3 (i, k, l, 2, 3, 0));
Times ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (189);
Epsilon (k,4);
Epsilon (j,1);
Epsilon (j,3);
Epsilon (i,1);
Push (Integer (-2));
Push (Integer (2));
Push (Minor2 (i, l, 2, 3));
Push (Minor2 (k, l, 2, 0));
Times ();
Times ();
Push (Minor2 (i, l, 3, 0));
Push (Minor2 (k, l, 4, 0));
Times ();
Push (Integer (2));
Push (Minor1 (l, 2));
Push (Minor3 (i, k, l, 2, 3, 0));
Times ();
Times ();
Push (Minor3 (i, k, l, 3, 4, 0));
Plus ();
Plus ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (190);
Epsilon (k,4);
Epsilon (j,1);
Epsilon (j,2);
Push (Integer (4));
Push (Minor2 (i, l, 2, 3));
Push (Minor3 (i, k, l, 1, 3, 0));
Times ();
Times ();
Push (Integer (2));
Push (Minor2 (i, l, 2, 0));
Push (Minor3 (i, k, l, 1, 4, 0));
Times ();
Times ();
Push (Integer (4));
Push (Minor2 (i, l, 1, 3));
Push (Minor3 (i, k, l, 2, 3, 0));
Times ();
Times ();
Push (Integer (2));
Push (Minor2 (i, l, 1, 0));
Push (Minor3 (i, k, l, 2, 4, 0));
Times ();
Times ();
Minus ();
Plus ();
Minus ();
Coefficient (Pop ());
Epsilon_Term (191);
Epsilon (k,4);
Epsilon (j,1);
Epsilon (j,2);
Epsilon (i,1);
Push (Integer (4));
Push (Minor2 (i, l, 2, 3));
Push (Minor2 (k, l, 3, 0));
Times ();
Times ();
Push (Integer (2));
Push (Minor2 (i, l, 2, 0));
Push (Minor2 (k, l, 4, 0));
Times ();
Times ();
Push (Integer (4));
Push (Minor1 (l, 3));
Push (Minor3 (i, k, l, 2, 3, 0));
Times ();
Times ();
Push (Integer (2));
Push (Minor3 (i, k, l, 2, 4, 0));
Times ();
Minus ();
Plus ();
Minus ();
Coefficient (Pop ());
Epsilon_Term (192);
Epsilon (k,4);
Epsilon (j,1);
Epsilon (j,1);
Push (Integer (2));
Push (Integer (-2));
Push (Minor2 (i, l, 2, 3));
Push (Minor3 (i, k, l, 2, 3, 0));
Times ();
Times ();
Push (Minor2 (i, l, 2, 0));
Push (Minor3 (i, k, l, 2, 4, 0));
Times ();
Push (Minor2 (i, l, 3, 0));
Push (Minor3 (i, k, l, 3, 4, 0));
Times ();
Plus ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (193);
Epsilon (k,4);
Epsilon (k,4);
Push (Minor3 (i, j, l, 1, 2, 0));
Push (Integer (2));
Power ();
Push (Minor3 (i, j, l, 1, 3, 0));
Push (Integer (2));
Power ();
Push (Minor3 (i, j, l, 2, 3, 0));
Push (Integer (2));
Power ();
Plus ();
Plus ();
Coefficient (Pop ());
Epsilon_Term (194);
Epsilon (k,4);
Epsilon (k,4);
Epsilon (i,3);
Push (Integer (-2));
Push (Minor2 (j, l, 1, 0));
Push (Minor3 (i, j, l, 1, 3, 0));
Times ();
Push (Minor2 (j, l, 2, 0));
Push (Minor3 (i, j, l, 2, 3, 0));
Times ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (195);
Epsilon (k,4);
Epsilon (k,4);
Epsilon (i,3);
Epsilon (i,3);
Push (Minor2 (j, l, 1, 0));
Push (Integer (2));
Power ();
Push (Minor2 (j, l, 2, 0));
Push (Integer (2));
Power ();
Plus ();
Coefficient (Pop ());
Epsilon_Term (196);
Epsilon (k,4);
Epsilon (k,4);
Epsilon (i,2);
Push (Integer (2));
Push (Minor2 (j, l, 1, 0));
Push (Minor3 (i, j, l, 1, 2, 0));
Times ();
Push (Minor2 (j, l, 3, 0));
Push (Minor3 (i, j, l, 2, 3, 0));
Times ();
Plus ();
Minus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (197);
Epsilon (k,4);
Epsilon (k,4);
Epsilon (i,2);
Epsilon (i,3);
Push (Integer (-2));
Push (Minor2 (j, l, 2, 0));
Push (Minor2 (j, l, 3, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (198);
Epsilon (k,4);
Epsilon (k,4);
Epsilon (i,2);
Epsilon (i,2);
Push (Minor2 (j, l, 1, 0));
Push (Integer (2));
Power ();
Push (Minor2 (j, l, 3, 0));
Push (Integer (2));
Power ();
Plus ();
Coefficient (Pop ());
Epsilon_Term (199);
Epsilon (k,4);
Epsilon (k,4);
Epsilon (i,1);
Push (Integer (2));
Push (Minor2 (j, l, 2, 0));
Push (Minor3 (i, j, l, 1, 2, 0));
Times ();
Push (Minor2 (j, l, 3, 0));
Push (Minor3 (i, j, l, 1, 3, 0));
Times ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (200);
Epsilon (k,4);
Epsilon (k,4);
Epsilon (i,1);
Epsilon (i,3);
Push (Integer (-2));
Push (Minor2 (j, l, 1, 0));
Push (Minor2 (j, l, 3, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (201);
Epsilon (k,4);
Epsilon (k,4);
Epsilon (i,1);
Epsilon (i,2);
Push (Integer (-2));
Push (Minor2 (j, l, 1, 0));
Push (Minor2 (j, l, 2, 0));
Times ();
Times ();
Coefficient (Pop ());
Epsilon_Term (202);
Epsilon (k,4);
Epsilon (k,4);
Epsilon (i,1);
Epsilon (i,1);
Push (Minor2 (j, l, 2, 0));
Push (Integer (2));
Power ();
Push (Minor2 (j, l, 3, 0));
Push (Integer (2));
Power ();
Plus ();
Coefficient (Pop ());
Epsilon_Term (203);
Epsilon (k,4);
Epsilon (k,4);
Epsilon (j,3);
Push (Integer (2));
Push (Minor2 (i, l, 1, 0));
Push (Minor3 (i, j, l, 1, 3, 0));
Times ();
Push (Minor2 (i, l, 2, 0));
Push (Minor3 (i, j, l, 2, 3, 0));
Times ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (204);
Epsilon (k,4);
Epsilon (k,4);
Epsilon (j,3);
Epsilon (i,3);
Push (Integer (-2));
Push (Minor2 (i, l, 1, 0));
Push (Minor2 (j, l, 1, 0));
Times ();
Push (Minor2 (i, l, 2, 0));
Push (Minor2 (j, l, 2, 0));
Times ();
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (205);
Epsilon (k,4);
Epsilon (k,4);
Epsilon (j,3);
Epsilon (i,2);
Push (Integer (2));
Push (Minor2 (i, l, 2, 0));
Push (Minor2 (j, l, 3, 0));
Times ();
Push (Minor3 (i, j, l, 2, 3, 0));
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (206);
Epsilon (k,4);
Epsilon (k,4);
Epsilon (j,3);
Epsilon (i,2);
Epsilon (i,3);
Push (Integer (-2));
Push (Minor2 (j, l, 2, 0));
Times ();
Coefficient (Pop ());
Epsilon_Term (207);
Epsilon (k,4);
Epsilon (k,4);
Epsilon (j,3);
Epsilon (i,2);
Epsilon (i,2);
Push (Integer (2));
Push (Minor2 (j, l, 3, 0));
Times ();
Coefficient (Pop ());
Epsilon_Term (208);
Epsilon (k,4);
Epsilon (k,4);
Epsilon (j,3);
Epsilon (i,1);
Push (Integer (2));
Push (Minor2 (i, l, 1, 0));
Push (Minor2 (j, l, 3, 0));
Times ();
Push (Minor3 (i, j, l, 1, 3, 0));
Plus ();
Times ();
Coefficient (Pop ());
Epsilon_Term (209);
Epsilon (k,4);
Epsilon (k,4);
Epsilon (j,3);
Epsilon (i,1);
Epsilon (i,3);
Push (Integer (-2));
Push (Minor2 (j, l, 1, 0));
Times ();
Coefficient (Pop ());
Epsilon_Term (210);
Epsilon (k,4);
Epsilon (k,4);
Epsilon (j,3);
Epsilon (i,1);
Epsilon (i,1);
Push (Integer (2));
Push (Minor2 (j, l, 3, 0));
Times ();
Coefficient (Pop ());
Epsilon_Term (211);
Epsilon (k,4);
Epsilon (k,4);
Epsilon (j,3);
Epsilon (j,3);
Push (Minor2 (i, l, 1, 0));
Push (Integer (2));
Power ();
Push (Minor2 (i, l, 2, 0));
Push (Integer (2));
Power ();
Plus ();
Coefficient (Pop ());
Epsilon_Term (212);
Epsilon (k,4);
Epsilon (k,4);
Epsilon (j,3);
Epsilon (j,3);
Epsilon (i,2);
Push (Integer (2));
Push (Minor2 (i, l, 2, 0));
Times ();
Coefficient (Pop ());
Epsilon_Term (213);
Epsilon (k,4);
Epsilon (k,4);
Epsilon (j,3);
Epsilon (j,3);
Epsilon (i,2);
Epsilon (i,2);
Push (Integer (1));
Coefficient (Pop ());
Finish ();
}

#endif  /* #if !defined(lint) */
